var hostcpuchart = echarts.init(document.getElementById("jv-cpu-chart"));
var hostmemoryUtilization = echarts.init(document.getElementById("jv-memory-chart"));
var diskReadChart = null;
var diskReadData = [];
var diskWriteChart = null;
var diskWriteData = [];


//网络发送
var sentChart = null;
var network_sent = [];
//网络接受
var receiveChart = null;
var network_io = [];

var hosttimer = null;

function vm_hostinfo() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: vmUrl,
      type: "POST",
      dataType: "json",
      async: true,
      data: JSON.stringify({
        "cmd": "vm_hostinfo",
        "token": UToken
      }),
      success: function(res) {
        // console.log(res);
        if (res.err == 0) {
          var info = res.results || {};
          jQuery('#jv-hostname').text(info.hostname);
          jQuery('#jv-vendor').text(info.host.hardware.vendor);
          jQuery('#jv-hosttype').text(info.host.product);
          jQuery('#jv-serial').text(info.host.hardware.serial);
          jQuery('#jv-firmwarevendor').text(info.host.firmware.vendor);
          jQuery('#jv-firmwareversion').text(info.host.firmware.version);
          jQuery('#jv-firmwaredate').text(info.host.firmware.release_date);

          jQuery('#jv-virtname').text(info.virt.hypervisor_string);
          jQuery('#jv-uri').text(info.virt.hypervisor_string);
          jQuery('#jv-virtmodel').text(info.cpu.model);

          jQuery('#jv-cpus').text(info.cpu.cpus);
          jQuery('#jv-cpunodes').text(info.cpu.nodes);
          jQuery('#jv-cpucores').text(info.cpu.cores);
          info.cpu.mhz && jQuery('#jv-cpumhz').text(info.cpu.mhz + ' ' + 'MHz');
          jQuery('#jv-cpusockets').text(info.cpu.sockets);
          jQuery('#jv-cputhreads').text(info.cpu.threads);

          get_storagevolumes_list(info);
          get_net_list(info);
          get_usb_list(info);
          get_pci_list(info);

          resolve(res);
        }
      },
      complete: function(XMLHttpRequest) {

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })
}

function setmemdata(info) {
  var totalmemory = info.mem.total;
  var usedmemory = info.mem.total - info.mem.free - info.mem.cached - info.mem.buffers;
  var freememory = info.mem.free;
  var buffersmemory = info.mem.buffers;
  var cachedmemory = info.mem.cached;
  jQuery('#jv-totalmemory').text(UNAS.getReadableSizeString(totalmemory * 1024));
  jQuery('#jv-usedmemory').text(UNAS.getReadableSizeString(usedmemory * 1024));
  jQuery('#jv-freememory').text(UNAS.getReadableSizeString(freememory * 1024));
  jQuery('#jv-buffersmemory').text(UNAS.getReadableSizeString(buffersmemory * 1024));
  jQuery('#jv-cachedmemory').text(UNAS.getReadableSizeString(cachedmemory * 1024));

  var memoryData = {
    value: usedmemory,
    name: 'Used Memory'
  };
  var free = {
    value: freememory,
    name: 'Free Memory'
  }
  var cached = {
    value: cachedmemory,
    name: 'Cached Memory'
  }
  var buffers = {
    value: buffersmemory,
    name: 'Buffered Memory'
  }

  hostmemoryUtilization.setOption({
    series: [{
      data: [cached, free, buffers, memoryData]
    }]
  });

}


// 存储列表
function get_storagevolumes_list(vm) {
  var disk = vm.storage || [];
  jQuery('#jv-hoststoragehost').empty();

  for (var i = 0; i < disk.length; i++) {
    var diskinfo = disk[i];
    var svdom = vmdTemplateAppend('#jv-hoststoragehost', 'jvt-sv-item', 'jvt-sv-item-' + i);
    svdom.attr('style', 'none').data('diskinfo', diskinfo);
    svdom.find('.jvc-name').text(diskinfo.name);
    svdom.find('.jvc-pos').text(diskinfo.capability.block);
    svdom.find('.jvc-bus').text(diskinfo.capability.bus);
    svdom.find('.jvc-vendor').text(diskinfo.capability.vendor);
    svdom.find('.jvc-model').text(diskinfo.capability.model);

    svdom.find('.view-icon').on('click', function(){
      var targetinfo = jQuery(this).parents('ul[name=vmditem]').data('diskinfo');
      viewHostConfigWindowFun(targetinfo.name);
    })
  }
}

// 网络列表
function get_net_list(vm){
  var disk = vm.net || [];
  jQuery('#jv-hostnethost').empty();

  for (var i = 0; i < disk.length; i++) {
    var diskinfo = disk[i];
    var svdom = vmdTemplateAppend('#jv-hostnethost', 'jvt-net-item', 'jvt-net-item-' + i);
    svdom.attr('style', 'none').data('diskinfo', diskinfo);
    svdom.find('.jvc-name').text(diskinfo.name);
    svdom.find('.jvc-interface').text(diskinfo.interface_name);
    svdom.find('.jvc-capabilities').text(diskinfo.capabilities);
    svdom.find('.jvc-address').text(diskinfo.address);
    svdom.find('.jvc-speed').text(diskinfo.speed >= 1 ? diskinfo.speed : '--');
    svdom.find('.jvc-state').text(diskinfo.state);

    svdom.find('.view-icon').on('click', function(){
      var targetinfo = jQuery(this).parents('ul[name=vmditem]').data('diskinfo');
      viewHostConfigWindowFun(targetinfo.name);
    })
  }
}
// USB列表
function get_usb_list(vm){
  var disk = vm.usb || [];
  jQuery('#jv-hostusbhost').empty();

  for (var i = 0; i < disk.length; i++) {
    var diskinfo = disk[i];
    var svdom = vmdTemplateAppend('#jv-hostusbhost', 'jvt-usb-item', 'jvt-usb-item-' + i);
    svdom.attr('style', 'none').data('diskinfo', diskinfo);
    svdom.find('.jvc-name').text(diskinfo.name);
    svdom.find('.jvc-vp').text(diskinfo.vendor_id + ':' + diskinfo.product_id);
    svdom.find('.jvc-driver').text(diskinfo.driver_name);
    svdom.find('.jvc-vendor').text(diskinfo.vendor_name);
    svdom.find('.jvc-product').text(diskinfo.product_name);

    svdom.find('.view-icon').on('click', function(){
      var targetinfo = jQuery(this).parents('ul[name=vmditem]').data('diskinfo');
      viewHostConfigWindowFun(targetinfo.name);
    })
  }
}
// PCI列表
function get_pci_list(vm){
  var disk = vm.pci || [];
  jQuery('#jv-hostpcihost').empty();

  for (var i = 0; i < disk.length; i++) {
    var diskinfo = disk[i];
    var svdom = vmdTemplateAppend('#jv-hostpcihost', 'jvt-pci-item', 'jvt-pci-item-' + i);
    svdom.attr('style', 'none').data('diskinfo', diskinfo);
    svdom.find('.jvc-name').text(diskinfo.name);
    svdom.find('.jvc-vp').text(diskinfo.vendor_id + ':' + diskinfo.product_id);
    svdom.find('.jvc-driver').text(diskinfo.driver_name);
    svdom.find('.jvc-vendor').text(diskinfo.vendor_name);
    svdom.find('.jvc-product').text(diskinfo.product_name);

    svdom.find('.view-icon').on('click', function(){
      var targetinfo = jQuery(this).parents('ul[name=vmditem]').data('diskinfo');
      viewHostConfigWindowFun(targetinfo.name);
    })
  }
}

function vm_hoststat() {
  clearTimeout(hosttimer);

  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_hoststat',
      token: UToken
    }),
    success: function(res) {
      // console.log(res);
      if (res.err == 0) {
        var info = res.results || {};
        var cpu_1 = info.cpu.total || {};
        var mem = info.mem || {};
        var total_1 = cpu_1.idle + cpu_1.iowait + cpu_1.kernel + cpu_1.user;
        var idle_1 = cpu_1.idle;
        var total_0 = 0;
        var idle_0 = 0;
        var hostinfo = jQuery('#jv-host-page').data('hostinfo');
        if (hostinfo) {
          cpu_0 = hostinfo.cpu.total || {};
          total_0 = cpu_0.idle + cpu_0.iowait + cpu_0.kernel + cpu_0.user;
          idle_0 = cpu_0.idle;
        }
        var cpu_p = 1 - (idle_1 - idle_0) / (total_1 - total_0);
        cpu_p = parseInt(cpu_p * 100) || 0;
        cpu_1.freq && jQuery('#jv-cpumhz').text(cpu_1.freq + ' ' + 'MHz');

        diskReadData_hostinfo(info);
        netData_hostinfo(info);

        jQuery('#jv-host-page').data('hostinfo', info);

        var color = '#1CDF7E';

        if (cpu_p > 50 && cpu_p <= 90) {
          color = '#FFC231';
        } else if (cpu_p > 90) {
          color = '#FF6854';
        } else {
          color = '#1CDF7E';
        }

        hostcpuchart.setOption({
          series: [{
            data: [cpu_p],
            color: {
              type: 'linear',
              colorStops: [{
                  offset: 0,
                  color: color
                },
                {
                  offset: 1,
                  color: color
                }
              ]
            },
          }]
        });

        setmemdata(info);
        if (jQuery('#jv-host-page').length) {
          hosttimer = setTimeout(function() {
            vm_hoststat();
            clearTimeout(hosttimer);
          }, 3000);
        }
      }
    },
    complete: function(XMLHttpRequest, textStatus) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });

}

function setCpu() {
  var cpuData = 0;
  // 内存使用率
  var optionCpu = {
    series: [{
      data: [cpuData],

      type: 'gauge',

      radius: '90%',
      center: ['50%', '50%'],

      startAngle: -270,
      endAngle: 90,
      clockwise: false,

      min: 0,
      max: 100,

      color: {
        type: 'linear',
        colorStops: [{
            offset: 0,
            color: '#1CDF7E'
          },
          {
            offset: 1,
            color: '#1CDF7E'
          }
        ]
      },

      axisLine: {
        lineStyle: {
          width: 10,
          opacity: 1,
          color: [
            [1, '#F1F1F1']
          ]
        }
      },

      progress: {
        show: true,
        overlap: false,
        roundCap: true
      },

      detail: {
        offsetCenter: [10, '0%'],
        valueAnimation: true,
        formatter: function(value) {
          return '{value|' + Math.round(value) + '%}  ';
        },
        rich: {
          value: {
            textAlign: 'center',
            fontSize: 18,
            fontWeight: 500,
            color: '#555'
          }
        }
      },

      axisTick: {
        show: false
      },
      pointer: {
        show: false
      },
      splitLine: {
        show: false,
      },
      axisLabel: {
        show: false
      }
    }]
  };
  hostcpuchart.setOption(optionCpu, true);
}

function setMemory() {
  var memoryData = {
    value: 0,
    name: 'Used Memory'
  };
  var free = {
    value: 0,
    name: 'Free Memory'
  }
  var cached = {
    value: 0,
    name: 'Cached Memory'
  }
  var buffers = {
    value: 0,
    name: 'Buffered Memory'
  }

  // 内存使用率

  var optionMemory = {
    tooltip: {
      trigger: 'item',
      show: false
    },
    legend: {
      top: '5%',
      left: 'center',
      show: false
    },
    series: [{
      name: 'memory',
      type: 'pie',
      radius: ['70%', '90%'],
      avoidLabelOverlap: false,
      hoverAnimation: true,
      label: {
        show: false,
        position: 'center'
      },
      emphasis: {
        label: {
          show: true,
          fontSize: '13',
          fontWeight: 'bold',
          formatter: function(params) {
            return [params.percent + '%', UNAS._('##$@vmdashboard@$##' + params.name + '##$@vmdashboard@$##')].join('\n');
          }
        }

      },
      labelLine: {
        show: false
      },
      data: [cached, free, buffers, memoryData]
    }]
  };

  hostmemoryUtilization.setOption(optionMemory, true);
}

//硬盘读写速度
function setchart(chart, data, ts) {
  chart.setOption({
    series: [{
      data: data
    }],
    xAxis: [{
      data: ts
    }],
    tooltip: {
      formatter: function(params) {}
    }
  });
}

function setOption(name, bgcolor, data) {
  var option = {
    animation: false,
    xAxis: {
      show: false,
      type: 'category',
      boundaryGap: false,
      data: [0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, '60s'],
      axisLabel: {
        fontSize: 10,
        // interval: 10
      },
      inverse: true,
    },

    tooltip: {
      trigger: 'axis',
      formatter: function(params) {
        var result = '';
        for (var i = 0; i < params.length; i++) {
          result = result + params[i].marker + params[i].seriesName + ': ' +
            UNAS.getReadableSpeedString(params[i].value) + '</br>';
        }
        return result;
      }
    },
    yAxis: {
      type: 'value',
      show: false,
    },

    grid: {
      top: 0,
      left: 0,
      right: 0,
      height: '100%',
      width: '100%'
    },
    series: [{
      data: data,
      name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##'),
      type: 'line',
      smooth: true,
      color: bgcolor.color0,
      areaStyle: {
        color: {
          type: 'linear',
          x: 0,
          y: 0,
          x2: 0,
          y2: 1,
          colorStops: [{
            offset: 0,
            color: bgcolor.color0 // 0% 处的颜色
          }, {
            offset: 1,
            color: bgcolor.color1 // 100% 处的颜色
          }],
          global: false // 缺省为 false
        },
        shadowBlur: 0,
        // opacity: 0.2
      },
      // 设置小圆点消失
      // 注意：设置symbol: 'none'以后，拐点不存在了，设置拐点上显示数值无效
      symbol: 'none',
      // 设置折线弧度，取值：0-1之间
      smooth: 1,
      lineStyle: {
        width: 2
      }
    }]

  };

  return option;
}

function setReceived_sent(name, color, data) {

  var option = {
    animation: false,
    xAxis: {
      show: false,
      type: 'category',
      boundaryGap: false,
      data: [0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, '60s'],
      axisLabel: {
        fontSize: 10,
        interval: 19
      },
      inverse: true
    },
    tooltip: {
      trigger: 'axis',
      formatter: function(params) {
        var result = '';
        for (var i = 0; i < params.length; i++) {
          result = result + params[i].marker + params[i].seriesName + ': ' + Math.abs(params[i]
            .value / 1024).toFixed(2) + 'KB/s' + '</br>';
        }
        return result;
      }
    },
    yAxis: {
      show: false,
      type: 'value',
      name: 'K/s'
    },
    grid: {
      top: 20,
      left: 0,
      right: 20,
      height: '58%',
      width: '90%'
    },
    series: {
      name: UNAS._(name),
      type: 'line',
      symbolSize: 0,
      color: color,
      smooth: true,
      data: data
    }
  };
  return option;
}


function viewHostConfigWindowFun(name) {
  var cwh = getClientWH();
  var viewHostConfigWindow = new MUI.Modal({
    id: 'jv-viewHostConfigWindow',
    title: UNAS._("##$@vmdashboard@$##XML Information##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/public/configinfo.html',
    modal: true,
    width: cwh.w,
    height: cwh.h, //parseInt(cwh.h * 0.84),
    type: 'modal2',
    addClass:'mobile-modal',
    data: {
      type: 'dev',
      uuid : name
    }
  });
}


function diskReadData_hostinfo(disk) {

  var diskinfo = jQuery('#jv-host-page').data('hostinfo');
  var disktime_1 = disk.time || 0;
  var rd_bytes_1 = 0;
  var wr_bytes_1 = 0;

  var disktime_0 = 0;
  var rd_bytes_0 = 0;
  var wr_bytes_0 = 0;

  rd_bytes_1 = disk.block.total.read_bytes || 0;
  wr_bytes_1 = disk.block.total.write_bytes || 0;
  if (diskinfo) {
    disktime_0 = diskinfo.time || 0;
    rd_bytes_0 = diskinfo.block.total.read_bytes || 0;
    wr_bytes_0 = diskinfo.block.total.write_bytes || 0;

    var rd_bytes = (rd_bytes_1 - rd_bytes_0) / (disktime_1 - disktime_0);
    var wr_bytes = (wr_bytes_1 - wr_bytes_0) / (disktime_1 - disktime_0);

    rd_bytes = isNaN(rd_bytes) ? 0 : parseInt(rd_bytes);
    wr_bytes = isNaN(wr_bytes) ? 0 : parseInt(wr_bytes);

    if (rd_bytes) {
      jQuery('#jv-vmread').text(UNAS.getReadableSpeedString(rd_bytes));
    }else {
      jQuery('#jv-vmread').text('0.0KB/s');
    }
    if (wr_bytes) {
      jQuery('#jv-vmwrite').text(UNAS.getReadableSpeedString(wr_bytes));
    }else {
      jQuery('#jv-vmwrite').text('0.0KB/s');
    }


    if (diskReadData.length > 31) {
      diskReadData.pop();
      diskWriteData.pop();
    }

    diskReadData.unshift(rd_bytes)

    diskReadChart.setOption({
      series: [{
        data: diskReadData
      }]
    });

    diskWriteData.unshift(wr_bytes)

    diskWriteChart.setOption({
      series: [{
        data: diskWriteData
      }]
    });

  }
}

function netData_hostinfo(info) {

  var netinfo = jQuery('#jv-host-page').data('hostinfo');
  var nettime_1 = info.time || 0;
  var rx_bytes_1 = 0;
  var tx_bytes_1 = 0;

  var nettime_0 = 0;
  var rx_bytes_0 = 0;
  var tx_bytes_0 = 0;

  rx_bytes_1 = info.net.total.rx_bytes || 0;
  tx_bytes_1 = info.net.total.tx_bytes || 0;

  if (netinfo) {
    nettime_0 = netinfo.time || 0;
    rx_bytes_0 = netinfo.net.total.rx_bytes || 0;
    tx_bytes_0 = netinfo.net.total.tx_bytes || 0;
  }

  var rx_bytes = (rx_bytes_1 - rx_bytes_0) / (nettime_1 - nettime_0);
  var tx_bytes = (tx_bytes_1 - tx_bytes_0) / (nettime_1 - nettime_0);

  rx_bytes = isNaN(rx_bytes) ? 0 : parseInt(rx_bytes);
  tx_bytes = isNaN(tx_bytes) ? 0 : parseInt(tx_bytes);

  if (rx_bytes) {
    jQuery('#jv-vmreceived').text(UNAS.getReadableSpeedString(rx_bytes));
  }else {
    jQuery('#jv-vmreceived').text('0.0KB/s');
  }
  if (tx_bytes) {
    jQuery('#jv-vmsent').text(UNAS.getReadableSpeedString(tx_bytes));
  }else {
    jQuery('#jv-vmsent').text('0.0KB/s');
  }


  if (network_sent.length > 31) {
    network_sent.pop();
    network_io.pop();
  }

  network_sent.unshift(tx_bytes)

  sentChart.setOption({
    series: [{
      data: network_sent
    }]
  });

  network_io.unshift(rx_bytes)

  receiveChart.setOption({
    series: [{
      data: network_io
    }]
  });

}

jQuery(document).ready(function() {

  vm_hostinfo().then(function() {
    vm_hoststat();
  });

  // jQuery("#jv-host-page").mCustomScrollbar({
  //   autoHideScrollbar: true,
  //   theme: "minimal-dark"
  // });

  setCpu();
  setMemory();

  diskReadChart = echarts.init(document.getElementById('jv-disk-read'))
  setOption('', diskReadData) && diskReadChart.setOption(setOption('Read', {
    color0: '#A1EEC8',
    color1: '#ECFBF4'
  }, diskReadData));

  diskWriteChart = echarts.init(document.getElementById('jv-disk-write'))
  setOption('', diskWriteData) && diskWriteChart.setOption(setOption('Write', {
    color0: '#FEDEA0',
    color1: '#FFF8E7'
  }, diskWriteData));

  sentChart = echarts.init(document.getElementById("jv-sent"));
  setReceived_sent('', network_sent) && sentChart.setOption(
    setReceived_sent('Sent', '#35DFFF', network_sent))

  receiveChart = echarts.init(document.getElementById("jv-received"));
  setReceived_sent('', network_io) && receiveChart.setOption(
    setReceived_sent('Received', '#FF7D4F', network_io))

});


(function() {


})()
