var createnetworkWindow = window.top.UNAS.GetWindow('jv-createnetworkWindow');
var options = createnetworkWindow.options;
var pagedata = options.data;

var iface_net = [];
var ovs_net = [];

// 创建网卡
function submitcreatenetworkinfo() {

  var name = jQuery('#jv-networkname').val();
  var type = jQuery('#network_type').val();

  var data = {
    cmd: 'vm_net_add',
    token: UToken,
    params: {
      name: name,
      type: type,
      start : true
    }
  };

  if (options.win_type == 'edit') {
    data.params['uuid'] = pagedata.uuid;
    data.cmd = 'vm_net_edit';
  }

  switch (type) {
    case 'nat':
      var mac_address = jQuery('#jv-macaddress').val();
      var ip_address = jQuery('#jv-ipaddress').val();
      var subnet_mask = jQuery('#jv-subnetmask').val();
      var dhcp = jQuery('#jv-dhcp').val();
      var dhcp_start_address = jQuery('#dhcp_start_address').val();
      var dhcp_end_address = jQuery('#dhcp_end_address').val();
      data['params']['mac_address'] = mac_address;
      data['params']['ip_address'] = ip_address;
      data['params']['subnet_mask'] = subnet_mask;
      data['params']['dhcp'] = dhcp;
      data['params']['dhcp_start_address'] = dhcp_start_address;
      data['params']['dhcp_end_address'] = dhcp_end_address;
      break;
    case 'bridged':
      var iface = jQuery('#jv-networkhost').val();
      var vlanid = jQuery('#jv-vlanID').val();
      var vlan = jQuery('#jv-vlan').prop('checked') ? vlanid : 0;
      data['params']['iface'] = iface;
      data['params']['vlan'] = +vlan;
      break;
    case 'ovs':
    case 'vepa':
    case 'passthrough':
    case 'macvtap':
      var iface = jQuery('#jv-networkhost').val();
      data['params']['iface'] = iface;
      break;
    case 'isolated':

      break;
    default:

  }

  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.stringify(data),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      if (res.err == 0) {
        vm_net_list();
        MUI.closeWindow($('jv-createnetworkWindow'));
        createnetworkWindow.cllback();
      } else {
        vm_errorWindowFn({
          tips: res.errmsg
        })
      }
    },
    complete: function(XMLHttpRequest, textStatus) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });

}


function vlanControl(t) {
  if (jQuery(t).prop('checked')) {
    jQuery('#jv-vlanID').attr('disabled', false);
  } else {
    jQuery('#jv-vlanID').attr('disabled', true);
  }
}

function network_type_changed(t) {

  updatednetoption(iface_net);
  jQuery('#jv-netalerttips').attr('class', 'alert-info-net')
    .html(UNAS._('##$@vmdashboard@$##Please insert a network cable into the target network interface, otherwise the virtual machine will not be able to get an IP address.##$@vmdashboard@$##'))

  switch (jQuery(t).val()) {
    case 'nat':
      jQuery('.nat-row').removeClass('hide-row');
      jQuery('.ovs-row').addClass('hide-row');
      jQuery('.bridged-row').addClass('hide-row');
      break;
    case 'bridged':
      jQuery('.nat-row').addClass('hide-row');
      jQuery('.ovs-row').removeClass('hide-row');
      jQuery('.bridged-row').removeClass('hide-row');
      break;
    case 'ovs':
      jQuery('.nat-row').addClass('hide-row');
      jQuery('.bridged-row').addClass('hide-row');
      jQuery('.ovs-row').removeClass('hide-row');
      updatednetoption(ovs_net);
      if (ovs_net.length == 0) {
        jQuery('#jv-netalerttips').attr('class', 'alert-warning-net')
          .html(UNAS._('##$@vmdashboard@$##No network interface available, go to CONTROL PANEL > SETTING > NETWORK SETTINGS, create a OVS network, and then refresh this page.##$@vmdashboard@$##'))
      }
      break;
    case 'vepa':
    case 'passthrough':
    case 'macvtap':
      jQuery('.nat-row').addClass('hide-row');
      jQuery('.bridged-row').addClass('hide-row');
      jQuery('.ovs-row').removeClass('hide-row');
      break;
    case 'isolated':
      jQuery('.nat-row').addClass('hide-row');
      jQuery('.bridged-row').addClass('hide-row');
      jQuery('.ovs-row').addClass('hide-row');
      break;
    default:

  }

}

function vm_net_if() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.stringify({
        cmd: 'vm_net_if',
        token: UToken
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(res) {
        var info = res.results || {};
        if (res.err == 0) {
          iface_net = info.iface || [];
          ovs_net = info.ovs || [];
        }
        updatednetoption(iface_net);
        resolve(res);
      },
      complete: function(XMLHttpRequest, textStatus) {

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
  })
}

function updatednetoption(network) {
  jQuery('#jv-networkhost').empty();
  var name = '';

  if (pagedata.bridge) {
    name = pagedata.bridge.attributes.name;
  }

  var op = '';
  for (var i = 0; i < network.length; i++) {
    var tp = network[i];
    var mac = tp.mac || '';
    if (tp.name == name) {
      op += '<option selected value="' + tp.name + '">' + tp.name + ' (' + mac + ')</option>';
    } else {
      op += '<option value="' + tp.name + '">' + tp.name + ' (' + mac + ')</option>';
    }

  }
  jQuery('#jv-networkhost').html(op);
}


function editinitdata() {
  jQuery('#jv-networkname').val(pagedata.name);
  jQuery('#network_type').val(pagedata.type);

  jQuery('#jv-netalerttips').attr('class', 'alert-info-net')
    .html(UNAS._('##$@vmdashboard@$##Please insert a network cable into the target network interface, otherwise the virtual machine will not be able to get an IP address.##$@vmdashboard@$##'))

  switch (pagedata.type) {
    case 'nat':
      jQuery('.nat-row').removeClass('hide-row');
      jQuery('.ovs-row').addClass('hide-row');
      jQuery('.bridged-row').addClass('hide-row');
      jQuery('#jv-macaddress').val(pagedata.mac.attributes.address);
      jQuery('#jv-ipaddress').val(pagedata.info.ip);
      jQuery('#jv-subnetmask').val(pagedata.info.netmask);
      // jQuery('#jv-dhcp').val();
      jQuery('#dhcp_start_address').val(pagedata.info.dhcp_start);
      jQuery('#dhcp_end_address').val(pagedata.info.dhcp_end);
      break;
    case 'bridged':
      jQuery('.nat-row').addClass('hide-row');
      jQuery('.ovs-row').removeClass('hide-row');
      jQuery('.bridged-row').removeClass('hide-row');
      var vlan = pagedata.bridge.attributes.vlan;
      if (vlan) {
        jQuery('#jv-vlan').prop('checked', 'true');
        jQuery('#jv-vlanID').attr('disabled', false).val(vlan);
      }
      break;
    case 'ovs':
      jQuery('.nat-row').addClass('hide-row');
      jQuery('.bridged-row').addClass('hide-row');
      jQuery('.ovs-row').removeClass('hide-row');
      setTimeout(function() {
        updatednetoption(ovs_net);
        if (ovs_net.length == 0) {
          jQuery('#jv-netalerttips').attr('class', 'alert-warning-net')
            .html(UNAS._('##$@vmdashboard@$##No network interface available, go to CONTROL PANEL > SETTING > NETWORK SETTINGS, create a OVS network, and then refresh this page.##$@vmdashboard@$##'))
        }
      }, 100)
      break;
    case 'vepa':
    case 'passthrough':
    case 'macvtap':
      jQuery('.nat-row').addClass('hide-row');
      jQuery('.bridged-row').addClass('hide-row');
      jQuery('.ovs-row').removeClass('hide-row');
      break;
    case 'isolated':
      jQuery('.nat-row').addClass('hide-row');
      jQuery('.bridged-row').addClass('hide-row');
      jQuery('.ovs-row').addClass('hide-row');
      break;
    default:

  }



}


(function() {
  var mac = generateRandomMacAddress();

  jQuery('#jv-macaddress').val(mac);

  vm_net_if().then(function() {
    if (options.win_type == 'edit') {
      editinitdata();
    } else {

    }
    jQuery('#jv-createnetwork-page').css('opacity', 1);
  });

  var netname = 'vnet0';
  for (var i = 0; i < 10000; i++) {
    var t_name = 'vnet' + i;
    if (netnamelist.indexOf(t_name) > -1) {
      continue
    } else {
      netname = 'vnet' + i;
      break;
    }
  }
  jQuery('#jv-networkname').val(netname);


})()
