var netnamelist = []

function vm_net_list() {
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "vm_net_list",
      token: UToken
    }),
    success: function(res) {
      jQuery('#jv-netlist-host').empty();
      var results = res.results || [];
      if (res.err == 0) {
        netnamelist = [];
        for (var i = 0; i < results.length; i++) {
          var info = results[i];
          netnamelist.push(info.name);
          var netdom = vmdTemplateAppend('#jv-netlist-host', 'jvt-netitem', 'jvt-netitem-' + i);
          netdom.data('netinfo', info);

          netdom.find('.jvc-netname').text(info.name || '--');
          netdom.find('.jvc-netiprange').text(info.info.ip_range || '--');
          netdom.find('.jvc-forwarding').text(info.type || '--');

          if (info.type == 'nat') {
            netdom.find('.jvc-netip').text(info.ip.attributes.address || '--');
            var start = info.ip.dhcp.range.attributes.start || '--';
            var end = info.ip.dhcp.range.attributes.end || '--';
            netdom.find('.jvc-dhcprange').text(start + '-' + end);
          } else {
            if (info.ip) {
              netdom.find('.jvc-netip').text(info.ip.attributes.address || '--');
              var start = info.ip.dhcp.range.attributes.start || '--';
              var end = info.ip.dhcp.range.attributes.end || '--';
              netdom.find('.jvc-dhcprange').text(start + '-' + end);
            }
          }

          var active = info.active ? 'Active' : 'Inactive';
          if (info.active) {
            netdom.find('.cc-start-btn').hide();
          } else {
            netdom.find('.cc-stop-btn').hide();
          }
          netdom.find('.jvc-netactive').addClass(active).text('##$@vmdashboard@$##' + active + '##$@vmdashboard@$##');

          if (info.name == 'default' || info.active) {
            netdom.find('.cc-edit-btn').remove();
            netdom.find('.cc-delete-btn').remove();
          }
          netdom.find('.jvc-netopbtn').css('opacity', 1);
        }
        vmdTranslator('jv-netlist-host');
      }
    },
    complete: function(XMLHttpRequest, textStatus) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {}

  });

}
//edit net
function editnetworkWindowFun(t) {
  var netinfo = jQuery(t).parents('.jvc-netnode').data('netinfo');
  createnetworkWindowFun(netinfo, 'edit');
}
// net active
function vm_net_active(cmd) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  var netinfo = jQuery(target).parents('.jvc-netnode').data('netinfo');

  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.stringify({
      cmd: cmd,
      token: UToken,
      params: {
        name: netinfo.uuid
      }
    }),
    success: function(res) {
      if (res.err == 0) {
        vm_net_list();
      }else {
        vm_errorWindowFn({
          tips : UNAS._(res.errmsg)
        })
      }
    },
    complete: function(XMLHttpRequest, textStatus) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

// del net
function vm_net_del(t) {
  var netinfo = jQuery(t).parents('.jvc-netnode').data('netinfo');

  vm_alertWindowFn({
    tips: UNAS._('##$@vmdashboard@$##Delete network?##$@vmdashboard@$##') + '</br>' + netinfo.name
  }, function() {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.stringify({
        cmd: 'vm_net_del',
        token: UToken,
        params: {
          name: netinfo.uuid
        }
      }),
      success: function(res) {
        if (res.err == 0) {
          vm_net_list();
        }else {
          vm_errorWindowFn({
            tips : UNAS._(res.errmsg)
          })
        }
      },
      complete: function(XMLHttpRequest, textStatus) {},
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
  });

}

function createnetworkWindowFun(data = {}, type = '') {
  var cwh = getClientWH();
  var createnetworkWindow = new MUI.Modal({
    id: 'jv-createnetworkWindow',
    title: UNAS._("##$@vmdashboard@$##Create Network##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/network/createnetwork.html',
    modal: true,
    modalOverlayClose: false,
    data: data,
    win_type : type,
    width: cwh.w,
    height: cwh.h,//parseInt(cwh.h * 0.84),
    type: 'modal2',
    addClass:'mobile-modal'
  });
  createnetworkWindow.cllback = function() {
    vm_net_list();
  }
}

function viewHostConfigWindowFun(type) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  var netinfo = jQuery(target).parents('.jvc-netnode').data('netinfo');
  var cwh = getClientWH();
  var viewHostConfigWindow = new MUI.Modal({
    id: 'jv-viewHostConfigWindow',
    title: UNAS._("##$@vmdashboard@$##XML Information##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/network/configinfo.html',
    modal: true,
    width: cwh.w,
    height: cwh.h, //parseInt(cwh.h * 0.84),
    type: 'modal2',
    addClass:'mobile-modal',
    modalOverlayClose: false,
    data: netinfo
  });
}


(function() {
  // jQuery("#jv-netlist-host").mCustomScrollbar({
  //   autoHideScrollbar: true,
  //   theme: "minimal-dark"
  // });
  vm_net_list();

})()
