function vm_pool_list() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: vmUrl,
      type: "POST",
      dataType: "json",
      async: true,
      data: JSON.stringify({
        "cmd": "vm_pool_list",
        "token": UToken
      }),
      success: function(res) {
        if (res.err == 0) {
          jQuery('#jv-vmstoragehost').empty();
          var info = res.results || {};
          for (var i = 0; i < info.length; i++) {
            var temp_info = info[i];
            var volumes = info[i].volumes || [];
            var toragedom = vmdTemplateAppend('#jv-vmstoragehost', 'jvt-storage-md', 'jvt-storage-md-' + i);
            var tbody = toragedom.find('.jvc-tbody');
            var state = ['Inactive', 'Building', 'Running', 'Degraded', 'Inaccessible'];

            toragedom.data('poolinfo', temp_info);
            toragedom.find('.jvc-poolname').text(temp_info.name);
            toragedom.find('.jvc-path').text(temp_info.path);
            toragedom.find('.jvc-storagestate').text('##$@vmdashboard@$##' + state[temp_info.state] + '##$@vmdashboard@$##');

            var s_capacity = +temp_info.capacity || 0;
            var s_allocation = +temp_info.allocation || 0;
            var s_available = +temp_info.available || 0;
            toragedom.find('.jvc-storagecapacity').text(UNAS.getReadableSizeString(s_capacity));
            toragedom.find('.jvc-storageallocation').text(UNAS.getReadableSizeString(s_allocation));
            toragedom.find('.jvc-storageavailable').text(UNAS.getReadableSizeString(s_available));

            var p = (s_allocation / s_capacity) * 100;
            p = isNaN(p) ? 0 : parseInt(p);
            if (p) {
              toragedom.find('.lui-inner').css('height', (p > 100 ? 100 : p) + '%');
              toragedom.find('.lui-column-bg').addClass('lui-column-gr');
            }

            switch (temp_info.state) {
              case 0:
                toragedom.find('.cc-newvolume-btn').remove();
                toragedom.find('.cc-stop-btn').remove();
                if (temp_info.domain) {
                  toragedom.find('.cc-delete-btn').remove();
                }
                break;
              case 1:
                toragedom.find('.cc-start-btn').remove();
                toragedom.find('.cc-stop-btn').remove();
                toragedom.find('.cc-newvolume-btn').remove();
                toragedom.find('.cc-delete-btn').remove();
                break;
              case 2:
              case 3:
                toragedom.find('.cc-start-btn').remove();
                toragedom.find('.cc-delete-btn').remove();
                break;
              case 4:
                toragedom.find('.cc-start-btn').remove();
                toragedom.find('.cc-newvolume-btn').remove();
                toragedom.find('.cc-delete-btn').remove();
                break;
              default:

            }

            toragedom.find('.cc-stop-btn').on('click', function() {
              var poolinfo = jQuery(this).parents('div[name=storage]').data('poolinfo');
              vm_poolstate_control('vm_pool_stop', {
                name: poolinfo.uuid
              });
            });
            toragedom.find('.cc-start-btn').on('click', function() {
              var poolinfo = jQuery(this).parents('div[name=storage]').data('poolinfo');
              vm_poolstate_control('vm_pool_start', {
                name: poolinfo.uuid
              });
            });
            toragedom.find('.cc-delete-btn').on('click', function() {
              var poolinfo = jQuery(this).parents('div[name=storage]').data('poolinfo');
              var txt = UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##');
              vm_alertWindowFn({
                tips: txt + ' ' + poolinfo.name + '?'
              }, function() {
                vm_poolstate_control('vm_pool_del', {
                  name: poolinfo.uuid
                });
              });

            });
            toragedom.find('.jvc-listtoggle').on('click', function() {
              var p_node = jQuery(this).parents('div[name=storage]');
              p_node.find('.storageinfolist-md').slideToggle();
              if (jQuery(this).hasClass('listtoggle-y')) {
                jQuery(this).removeClass('listtoggle-y').addClass('listtoggle-n');
              } else {
                jQuery(this).addClass('listtoggle-y').removeClass('listtoggle-n');
              }
            });

            if (volumes.length) {
              for (var j = 0; j < volumes.length; j++) {
                var temp_volume = volumes[j];
                var volumes_dom = vmdTemplateAppend(tbody, 'jvt-volumes-item', 'jvt-volumes-item-' + i + j);
                var type = ["File", "Block", "Dir", "Network", "NetDir", "Ploop"];
                var capacity = +temp_volume.capacity || 0;
                var allocation = +temp_volume.allocation || 0;
                capacity = UNAS.getReadableSizeString(capacity);
                allocation = UNAS.getReadableSizeString(allocation);
                volumes_dom.attr('style', 'none').data('volumeinfo', temp_volume);
                volumes_dom.find('.jvc-name').text(temp_volume.name);
                volumes_dom.find('.jvc-type').text(type[temp_volume.type]);
                volumes_dom.find('.jvc-capacity').text(capacity);
                volumes_dom.find('.jvc-allocation').text(allocation);
                volumes_dom.find('.jvc-path').text(temp_volume.path);

                volumes_dom.find('.jvc-path').text(temp_volume.path);


                if (temp_volume.domain) {
                  volumes_dom.find('.jvc-runningin').show();
                  volumes_dom.find('.jvc-volumeop').hide();
                  volumes_dom.find('.jvc-vmname').data('vminfo', temp_volume.domain);
                  volumes_dom.find('.jvc-vmname').text(temp_volume.domain.domain)
                    .on('click', function() {
                      var vminfo = jQuery(this).data('vminfo');
                      vmuuid = vminfo.uuid;
                      backhtml = '/apps/vmdashboard/m/page/storage/storage.html';
                      updatevmpage('/apps/vmdashboard/m/page/vmdetail/vmdetail.html');
                    }).attr('title', temp_volume.domain.domain);

                } else {
                  volumes_dom.find('.jvc-runningin').hide();
                  volumes_dom.find('.jvc-volumeop').show();
                }
              }
            } else {
              toragedom.find('.storageinfolist-md').hide();
            }
          }
        }

        vmdTranslator('jv-vmstoragehost');
        resolve(res);
      },
      complete: function(XMLHttpRequest) {

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })
}

function vm_poolstate_control(cmd, params) {
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: cmd,
      token: UToken,
      params: params
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {

    },
    complete: function(XMLHttpRequest, textStatus) {
      vm_pool_list();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

function createStorageVolumeFn(t) {
  var cwh = getClientWH();
  var poolinfo = jQuery(t).parents('div[name=storage]').data('poolinfo');
  var createstoragevolumeWindow = new MUI.Modal({
    id: 'jv-createStorageVolumeWindow',
    title: UNAS._("##$@vmdashboard@$##Create New Volume##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/storage/createstoragevolume.html',
    modal: true,
    modalOverlayClose: false,
    width: cwh.w,
    height: cwh.h, //parseInt(cwh.h * 0.6),
    type: 'modal2',
    addClass: 'mobile-modal',
    data: {
      uuid: poolinfo.uuid,
      name: poolinfo.name
    }
  });
  createstoragevolumeWindow.cllback = function() {

  }
}
//
function cloneStorageVolumeFn(t) {
  var cwh = getClientWH();
  var poolinfo = jQuery(t).parents('div[name=storage]').data('poolinfo');
  var volumeinfo = jQuery(t).parents('ul[name=vmditem]').data('volumeinfo');
  var cloneWindow = new MUI.Modal({
    id: 'jv-cloneWindow',
    title: UNAS._("##$@vmdashboard@$##Clone Storage Volume##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/storage/clone.html',
    modal: true,
    modalOverlayClose: false,
    data: {
      pool: poolinfo.uuid,
      source: volumeinfo.path
    },
    width: parseInt(cwh.w * 0.84),
    height: parseInt(cwh.h * 0.26),
    addClass:'delete-modal'
  });
  cloneWindow.cllback = function() {

  }
}

// 删除卷
function deleteStorageVolume(t) {
  var poolinfo = jQuery(t).parents('div[name=storage]').data('poolinfo');
  var volumeinfo = jQuery(t).parents('ul[name=vmditem]').data('volumeinfo');
  var txt = UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##');
  vm_alertWindowFn({
    tips: txt + ' ' + volumeinfo.name + '?'
  }, function() {
    vm_poolstate_control('vm_pool_volume_del', {
      name: volumeinfo.name,
      pool: poolinfo.uuid
    })
  });
}

function searchStorage(e){
  var event = window.event || arguments.callee.caller.arguments[0];
  var t = event.target;
  if (e) {
    t = e;
  }
  var v = jQuery(t).val().trim();
  jQuery("#jv-vmstoragehost>div:contains(" + v + ")").show();
  jQuery("#jv-vmstoragehost>div:not(:contains(" + v + "))").hide();
}

jQuery(document).ready(function() {
  vm_pool_list();

  // jQuery("#jv-vmstoragemain").mCustomScrollbar({
  //   autoHideScrollbar: true,
  //   theme: "minimal-dark"
  // });

})
