function vm_domain_define() {

  var memory = jQuery('input[field="memory"]').val();
  var memory_unit = jQuery('input[field="memory_unit"]:checked').val();

  if (memory_unit == 'MiB') {
    memory = memory * 1024;
  } else {
    memory = memory * 1024 * 1024;
  }

  if (memory > hostmemory) {
    vm_errorWindowFn({
      tips: UNAS._('Physical memory') + "：" + hostmemory
    })
    return;
  }

  var params = {
    uefi: jQuery('#jv-uefi').prop('checked'),
    description: jQuery('#jv-description').val(),
    start: jQuery('#jv-autostart').prop('checked'),
    tpm : jQuery('#jv-tpm').prop('checked')
  };

  var input_number = jQuery('#jv-createvmmain-page input[type="number"]');
  var input_text = jQuery('#jv-createvmmain-page input[type="text"]');
  var input_radio = jQuery('#jv-createvmmain-page input[type="radio"]:checked');
  var select = jQuery('#jv-createvmmain-page select');

  for (var i = 0; i < input_number.length; i++) {
    var temp_number = input_number[i];
    if (!jQuery(temp_number).prop('disabled')) {
      if (jQuery(temp_number).val()) {
        var field = jQuery(temp_number).attr('field');
        params[field] = parseInt(jQuery(temp_number).val());
        jQuery(temp_number).attr('class', 'unas_input');
      } else {
        jQuery(temp_number).attr('class', 'unas_input_error');
        return;
        break;
      }
    }
  }

  for (var i = 0; i < input_text.length; i++) {
    var temp_text = input_text[i];
    if (!jQuery(temp_text).prop('disabled')) {
      if (jQuery(temp_text).val()) {
        var field = jQuery(temp_text).attr('field');
        params[field] = jQuery(temp_text).val();
        jQuery(temp_text).attr('class', 'unas_input');
      } else {
        if (jQuery(temp_text).attr('field') != 'iso') {
          jQuery(temp_text).attr('class', 'unas_input_error');
          return;
          break;
        }
      }
    }
  }

  for (var i = 0; i < input_radio.length; i++) {
    var temp_radio = input_radio[i];
    if (!jQuery(temp_radio).prop('disabled')) {
      var field = jQuery(temp_radio).attr('field');
      params[field] = jQuery(temp_radio).val();
    }
  }

  for (var j = 0; j < select.length; j++) {
    var temp_select = select[j];
    if (!jQuery(temp_select).prop('disabled')) {
      var field = jQuery(temp_select).attr('field');
      if (jQuery(temp_select).val() == 'true' || jQuery(temp_select).val() == 'false') {
        params[field] = JSON.parse(jQuery(temp_select).val());
      } else {
        params[field] = jQuery(temp_select).val();
      }
    }
  }

  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_domain_define',
      token: UToken,
      params: params
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      if (res.err == 0) {
        vm_domain_list();
        MUI.closeWindow($('jv-createVMWindow'));
      } else {
        vm_errorWindowFn({
          tips: UNAS._(res.errmsg)
        })
      }
    },
    complete: function(XMLHttpRequest, textStatus) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}


function openinfolist() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  var node_p = jQuery(target).closest('div.createvminfo-md');

  if (node_p.find('.infocontent').is(':visible')) {
    jQuery(target).attr('class', 'closelist');
  } else {
    jQuery(target).attr('class', 'openlist');
  }
  node_p.find('.infocontent').slideToggle();
}

function autoStartControl(t, callback) {
  jQuery(t).toggleClass("open").children(".switch-btn").toggleClass("right");

  var clickType = jQuery(t).hasClass('open') ? true : false;

  if (typeof callback === 'function') {
    callback(clickType);
  }

}

function vncautoportControl(t) {
  if (jQuery(t).val() == 'true') {
    jQuery('#jv-vncport').attr('disabled', true);
  } else {
    jQuery('#jv-vncport').attr('disabled', false);
  }
}

function vncconnectControl(t) {
  if (jQuery(t).val() == 'true') {
    jQuery('#jv-vnc-password').attr('disabled', false);
  } else {
    jQuery('#jv-vnc-password').attr('disabled', true);
  }
}

function selectvolumeControl(t) {
  var type = jQuery(t).val();
  switch (type) {
    case 'create':
      jQuery('#jv-volumename-item').removeClass('hideitem').find('input').attr('disabled', false);
      jQuery('#jv-volsize-item').removeClass('hideitem').find('input').attr('disabled', false);
      jQuery('#jv-drivertype-item').removeClass('hideitem').find('select').attr('disabled', false);
      jQuery('#jv-targetbus-item').removeClass('hideitem').find('select').attr('disabled', false);
      jQuery('#jv-storagevolume-item').addClass('hideitem').find('input').attr('disabled', true);
      jQuery('#jv-passthrough-item').addClass('hideitem').find('select').attr('disabled', true);
      break;
    case 'exist':
      jQuery('#jv-volumename-item').addClass('hideitem').find('input').attr('disabled', true);
      jQuery('#jv-volsize-item').addClass('hideitem').find('input').attr('disabled', true);
      jQuery('#jv-drivertype-item').removeClass('hideitem').find('select').attr('disabled', false);
      jQuery('#jv-targetbus-item').removeClass('hideitem').find('select').attr('disabled', false);
      jQuery('#jv-storagevolume-item').removeClass('hideitem').find('input').attr('disabled', false);
      jQuery('#jv-passthrough-item').addClass('hideitem').find('select').attr('disabled', true);
      break;
    case 'passthrough':
      jQuery('#jv-volumename-item').addClass('hideitem').find('input').attr('disabled', true);
      jQuery('#jv-volsize-item').addClass('hideitem').find('input').attr('disabled', true);
      jQuery('#jv-drivertype-item').addClass('hideitem').find('select').attr('disabled', true);
      jQuery('#jv-storagevolume-item').addClass('hideitem').find('input').attr('disabled', true);
      jQuery('#jv-targetbus-item').addClass('hideitem').find('select').attr('disabled', true);
      jQuery('#jv-passthrough-item').removeClass('hideitem').find('select').attr('disabled', false);
      break;
    default:

  }
}

function vm_list_blk() {
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_list_blk',
      token: UToken
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {

      if (res.err == 0) {
        var info = res.results || [];
        jQuery('#jv-devlist').empty();
        var d = '';
        for (var i = 0; i < info.length; i++) {
          d += '<option value="/dev/' + info[i].name + '">/dev/' + info[i].name + '</option>';
        }

        jQuery('#jv-devlist').html(d);
      }
    },
    complete: function(XMLHttpRequest, textStatus) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}


function vm_net_list() {

  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.stringify({
        cmd: "vm_net_list",
        token: UToken
      }),
      success: function(res) {
        jQuery('#jv-virtualnetwork').empty();
        var results = res.results || [];
        if (res.err == 0) {
          var h = '';
          for (var i = 0; i < results.length; i++) {
            var info = results[i];
            h += '<option value="' + info.uuid + '">' + info.name + '</option>';

          }
          jQuery('#jv-virtualnetwork').html(h);
        }
      },
      complete: function(XMLHttpRequest, textStatus) {
        resolve(XMLHttpRequest);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}

    });

  })

}


function uploadFile(file, dir, targetinput) {
  var chunkSize = 1024 * 1024; // 每片文件大小（1MB）
  var fileSize = file.size;
  var offset = 0;
  var progress = 0;
  var filename_encoded = encodeURIComponent(file.name);

  // 切片并上传
  function readAndUpload() {
    var reader = new FileReader();
    var blob = file.slice(offset, offset + chunkSize);
    var p_node = jQuery(targetinput).closest('li.vm-item');
    p_node.find('.uploadloading').show();

    reader.onload = function(event) {
      var xhr = new XMLHttpRequest();
      xhr.open('POST', '/apps/vmdashboard/includes/upload.php', true);
      xhr.setRequestHeader('X-Target-Dir', dir);
      xhr.setRequestHeader('X-File', filename_encoded);
      xhr.setRequestHeader('X-Offset', offset);
      xhr.setRequestHeader('X-Size', fileSize);
      xhr.setRequestHeader('X-Chunk-Size', chunkSize);

      xhr.onload = function(data) {
        var res = JSON.parse(xhr.responseText);
        if (xhr.status === 200) {
          // 继续上传下一片
          if (res.err == 0) {
            offset += chunkSize;
            if (offset < fileSize) {
              readAndUpload();
              progress = ((offset / fileSize) * 100).toFixed(2);
              jQuery(targetinput).css('pointer-events', 'none');
              jQuery(targetinput).attr('placeholder', 'Uploading[' + progress + '%]: ' + file.name);
              jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn-disabled');
              jQuery('input[name="fileInput"]').attr('class', 'filest-disabled');
            } else {
              progress = 100;
              jQuery(targetinput).attr('placeholder', 'Uploading[' + progress + '%]: ' + file.name);
              jQuery(targetinput).css('pointer-events', 'auto');

              if (jQuery('input[name="storagepath"]').val()) {
                jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn');
                jQuery('input[name="fileInput"]').attr('class', 'filest');
              }else {
                jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn-disabled');
                jQuery('input[name="fileInput"]').attr('class', 'filest-disabled');
              }
              jQuery(targetinput).val(dir + '/' + file.name);

              p_node.find('.uploadloading').hide();
            }
          }else {
            // console.error('文件上传失败.');
            vm_errorWindowFn({
              tips : UNAS._(uploadFilerrcode[res.err])
            })
            p_node.find('.uploadloading').hide();
          }

        } else {
          // console.error('文件上传失败.');
          jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn');
          jQuery('input[name="fileInput"]').attr('class', 'filest');
          vm_errorWindowFn({
            tips : UNAS._('File upload failed')
          })
          p_node.find('.uploadloading').hide();
        }
      };

      xhr.onerror = function() {
        jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn');
        jQuery('input[name="fileInput"]').attr('class', 'filest');
        p_node.find('.uploadloading').hide();
        vm_errorWindowFn({
          tips : UNAS._('Network error, file upload failed')
        })

      };

      xhr.send(event.target.result);
    };

    reader.readAsArrayBuffer(blob);
  }

  // 开始切片上传
  readAndUpload();
}

(function() {

  showpage('#jv-createvm-page');

  // jQuery("#jv-createvmmain-page").mCustomScrollbar({
  //   autoHideScrollbar: true,
  //   theme: "minimal-dark"
  // });

  jQuery('#jv-macaddress').val(generateRandomMacAddress());
  vm_list_blk();

  jQuery('#jv-vmname').bind('input propertychange', function() {

    jQuery('#jv-volumename').val(jQuery(this).val() + '.qcow2');

  });
  vm_net_list();

  UNAS.Event.addEvent('dirChange', function() {
    if (jQuery('#jv-storagepath').val()) {
      jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn');
      jQuery('input[name="fileInput"]').attr('class', 'filest');
    } else {
      jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn-disabled');
      jQuery('input[name="fileInput"]').attr('class', 'filest-disabled');
    }
  });

  jQuery('#jv-fileInput-create').change(function(e) {
    var file = e.target.files[0];
    var dir = jQuery('#jv-storagepath').val();
    if (file) {
      uploadFile(file, dir, '#jv-importfile-create');
    }
  });

  jQuery('#jv-fileInput-sv').change(function(e) {
    var file = e.target.files[0];
    var dir = jQuery('#jv-storagepath').val();
    if (file) {
      uploadFile(file, dir, '#jv-importfile-sv');
    }
  });

})()
