var cmds = {
  reboot: 'vm_power_reboot',
  reset: 'vm_power_reset',
  poweron: 'vm_power_on',
  shutdown: 'vm_power_off',
  destroy: 'vm_power_destroy',
  delete: 'vm_domain_undefine',
  pause: 'vm_suspend',
  force: 'vm_suspend_rm',
  resume: 'vm_power_resume'
}
var import_vms = [];
var hostmemory = 0;
//vm list
function vm_domain_list() {
  clearTimeout(window.cuptimer);
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.stringify({
        cmd: 'vm_domain_list',
        token: UToken
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(res) {
        jQuery('#jv-vmlist-host').empty();
        cancelVmdSelected();
        jQuery('#jv-selectAllVM').prop('checked', false);
        var info = res.results || {};
        var vmlist = info.vm || [];
        hostmemory = info.cpu.memory || 0;
        for (var i = 0; i < vmlist.length; i++) {
          var vmdinfo = vmlist[i];
          var vmdom = vmdTemplateAppend('#jv-vmlist-host', 'jvt-vmditem', 'jvt-vmditem-' + i);
          vmdom.attr('style', '').data('vmdinfo', vmdinfo);
          vmdom.find('.jvc-vmname').text(vmdinfo.name);
          vmdom.find('.jvc-cpuchart').attr('id', 'jv-cpuchart-' + i);
          var maximum = vmdinfo.balloon.maximum || 0;
          var memory = UNAS.getReadableSizeString(maximum * 1024);
          vmdom.find('.jvc-memory').text(memory);
          vmdinfo.state = vmdinfo.state || {};
          var vmdstate = '';
          var state = vmdinfo.state.state;
          var reason = vmdinfo.state.reason;
          if (state == 1) {
            vmdstate = 'Running';
          } else if (state == 3) {
            vmdstate = 'Paused';
          } else if (state == 7) {
            vmdstate = 'Pmsuspend';
          } else if (state == 5) {
            if (reason == 5) {
              vmdstate = 'Paused';
            } else {
              vmdstate = 'Shutoff';
            }
          }
          vmdom.find('.jvc-vmdstate').text('##$@vmdashboard@$##' + vmdstate + '##$@vmdashboard@$##')
            .addClass(vmdstate);

          getvmdstate(vmdom, state, reason);
        }
        resolve(jQuery('#jv-vmlist-host').children());
        vmdTranslator('jv-vmlist-host');
      },
      complete: function(XMLHttpRequest, textStatus) {},
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
  }).then(function(data) {
    vm_domain_stat(data);
  })
}

function getvmdstate(t, state, reason) {
  switch (state) {
    case 0:

      break;
    case 7:
    case 1:
      t.find('.delete-icon').remove();
      t.find('.clone-icon').remove();
      t.find('.export-icon').remove();
      t.find('.poweron-icon').remove();
      t.find('.resume-icon').remove();
      t.find('.forced-icon').hide();
      t.find('.resume-icon-3').hide();
      break;
    case 2:

      break;
    case 3:
      t.find('.shutdown-icon').remove();
      t.find('.reboot-icon').remove();
      t.find('.resume-icon').hide();
      t.find('.managedsave-icon').remove();
      t.find('.reset-icon').remove();
      t.find('.poweroff-icon').remove();
      t.find('.clone-icon').remove();
      t.find('.delete-icon').remove();
      t.find('.poweron-icon').remove();
      t.find('.resume-icon-3').show();
      t.find('.forced-icon').hide();
      break;
    case 4:

      break;
    case 5:
      t.find('.shutdown-icon').remove();
      t.find('.reboot-icon').remove();
      t.find('.resume-icon').hide();
      t.find('.managedsave-icon').remove();
      t.find('.reset-icon').remove();
      t.find('.poweroff-icon').remove();
      t.find('.forced-icon').hide();
      t.find('.resume-icon-3').hide();
      if (reason == 5) {
        t.find('.clone-icon').remove();
        t.find('.delete-icon').remove();
        t.find('.poweron-icon').remove();
        t.find('.resume-icon').show();
        t.find('.forced-icon').show();
        t.find('.export-icon').remove();
      }
      break;
    case 6:

      break;

    default:
      t.find('.jvc-vmdop').hide();
      t.find('.view-icon').hide();
  }
}

//选择操作
function selectActions() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  event.stopPropagation();
  jQuery('#jv-actions-op').slideToggle();
  jQuery('#jv-actions-op li').off('click').on('click', function(e) {
    e.stopPropagation();
    var type = jQuery(this).attr('type');
    var uuids = [];
    jQuery('#jv-vmlist-host').children().each(function(i, ev) {
      if (jQuery(ev).find('.vmcheckbox').prop('checked')) {
        var nodeinfo = jQuery(ev).data('vmdinfo');
        uuids.push(nodeinfo.uuid);
      }
    })

    jQuery('#jv-actions-op').slideUp();
    if (uuids.length) {
      vm_power_control(cmds[type], uuids, type);
    }

  })

  jQuery(document).click(function(e) {
    event.stopPropagation();
    jQuery('#jv-actions-op').slideUp();
  });
}

// 新建虚拟机
function createVMWindowFun() {
  var cwh = getClientWH();
  var createVMWindow = new MUI.Modal({
    id: 'jv-createVMWindow',
    title: UNAS._("##$@vmdashboard@$##Create Virtual Machine##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/vm/create_vm.html',
    modal: true,
    modalOverlayClose: false,
    width: cwh.w,
    type: 'modal2',
    height: cwh.h,    //parseInt(cwh.h * 0.90),
    addClass: 'mobile-modal'
  });
}

// 查看虚拟机详情
function viewVmDetail(t) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  var nodeinfo = jQuery(t).parents('ul[name=vmditem]').data('vmdinfo');
  vmuuid = nodeinfo.uuid;
  backhtml = '/apps/vmdashboard/m/page/vm/vm.html';
  updatevmpage('/apps/vmdashboard/m/page/vmdetail/vmdetail.html');

}

// 导入虚拟机
function importVMWindowFun() {
  var cwh = getClientWH();
  var importVMWindow = new MUI.Modal({
    id: 'jv-importVMWindow',
    title: UNAS._("##$@vmdashboard@$##Import Domain##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/vm/import_vm.html',
    modal: true,
    modalOverlayClose: false,
    width: cwh.w,
    height: cwh.h, //parseInt(cwh.h * 0.88),
    type: 'modal2',
    addClass: 'mobile-modal',
    onClose: function() {
      UNAS.Event.removeEvent('sourceChange');
    }
  });
}
// 导出虚拟机
function exportVMWindowFun(t) {
  var cwh = getClientWH();
  var nodeinfo = jQuery(t).parents('ul[name=vmditem]').data('vmdinfo');
  var data = {
    uuid: nodeinfo.uuid,
    name: nodeinfo.name
  }
  var exportVMWindow = new MUI.Modal({
    id: 'jv-exportVMWindow',
    title: UNAS._("##$@vmdashboard@$##Export Domain##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/vm/export_vm.html',
    modal: true,
    data: data,
    modalOverlayClose: false,
    width: cwh.w,
    height: cwh.h, //parseInt(cwh.h * 0.8),
    type: 'modal2',
    addClass: 'mobile-modal'
  });
}
// 创建快照
function createSnapshotWindowFun(t) {
  var cwh = getClientWH();
  var nodeinfo = jQuery(t).parents('ul[name=vmditem]').data('vmdinfo');
  var data = {
    uuid: nodeinfo.uuid,
  }
  var createSnapshotWindow = new MUI.Modal({
    id: 'jv-createSnapshotWindow',
    title: UNAS._("##$@vmdashboard@$##Create Snapshot##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/vm/createsnapshot.html',
    modal: true,
    modalOverlayClose: false,
    data: data,
    width: parseInt(cwh.w * 0.88),
    height: parseInt(cwh.h * 0.5),
    addClass: 'delete-modal'
  });
}

// 克隆
function cloneWindowFun(t) {
  var cwh = getClientWH();
  var nodeinfo = jQuery(t).parents('ul[name=vmditem]').data('vmdinfo');
  var vm_names = [];
  jQuery('#jv-vmlist-host').children().each(function(i, ev) {
    var nodeinfo = jQuery(ev).data('vmdinfo');
    vm_names.push(nodeinfo.name);
  })
  var data = {
    uuid: nodeinfo.uuid,
    name: nodeinfo.name,
    vm_names: vm_names
  }
  var cloneWindow = new MUI.Modal({
    id: 'jv-cloneWindow',
    title: UNAS._("##$@vmdashboard@$##Clone##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/m/page/vm/clone.html',
    modal: true,
    data: data,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.88),
    height: parseInt(cwh.h * 0.36),
    addClass: 'delete-modal'
  });
}
// 删除
function deletevmd(t) {
  var nodeinfo = jQuery(t).parents('ul[name=vmditem]').data('vmdinfo');
  var type = jQuery(t).attr('type');
  var uuid = [nodeinfo.uuid];

  vm_alertWindowFn({
    tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##') + '?'
  }, function() {
    vm_power_control(cmds[type], uuid, type);
  });
}

//
function vmdControlOp(t) {
  var nodeinfo = jQuery(t).parents('ul[name=vmditem]').data('vmdinfo');
  var uuids = [nodeinfo.uuid];
  var type = jQuery(t).attr('type');
  var ts = {
    shutdown: 'Shutdown',
    reboot: 'Reboot',
    pause: 'Pause(Save on Disk)',
    reset: 'Reset',
    destroy: 'Power off',
    forced: 'Power off'
  }
  if (ts[type]) {
    var opt = UNAS._('##$@vmdashboard@$##' + ts[type] + '##$@vmdashboard@$##');
    vm_confirmalertWindowFn({
      tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to ##$@vmdashboard@$##') + opt + '?'
    }, function() {
      vm_power_control(cmds[type], uuids, type);
    });
  } else {
    vm_power_control(cmds[type], uuids, type);
  }
}

// get  cpu data
function vm_domain_stat(doms) {
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.stringify({
      cmd: 'vm_domain_stat',
      token: UToken
    }),
    success: function(res) {
      // console.log(res);
      var info = res.results || [];
      for (var i = 0; i < info.length; i++) {
        var tmp = info[i];
        var cputime1 = 0;
        var datatime1 = 0;
        if (tmp.cpu) {
          cputime1 = tmp.cpu.time || 0;
        }
        if (tmp.time) {
          datatime1 = tmp.time || 0;
        }
        doms.each(function(i, e) {
          var nodeinfo = jQuery(e).data('vmdinfo') || {};
          if (nodeinfo.uuid == tmp.uuid) {
            var cpuinfo = jQuery(e).find('.jvc-cpuchart').data('cpuinfo');
            var usemem = '0MB';
            if (tmp.mem) {
              usemem = UNAS.getReadableSizeString(tmp.mem['7'] * 1024);
            }

            jQuery(e).find('.jvc-usemem').text(usemem);

            var cputime0 = 0;
            var datatime0 = 0;
            var p = 0;
            if (cpuinfo) {
              if (cpuinfo.cpu) {
                cputime0 = cpuinfo.cpu.time;
              }
              if (cpuinfo.time) {
                datatime0 = cpuinfo.time;
              }
            }
            p = (cputime1 - cputime0) / (datatime1 - datatime0);
            p = isNaN(p) ? 0 : parseInt(p * 100);
            p = p ? parseInt((p / nodeinfo.vcpu.current)) : 0;
            if (p > 100) {
              p = 100;
            }
            jQuery(e).find('.jvc-cpuchart').attr('title', p + '%');

            jQuery(e).find('.jvc-cpuchart')[0] && cpuinit(jQuery(e).find('.jvc-cpuchart')[0], p);
          }
        })
      }

      for (var i = 0; i < info.length; i++) {
        var tmp = info[i];
        doms.each(function(i, e) {
          var nodeinfo = jQuery(e).data('vmdinfo') || {};
          if (nodeinfo.uuid == tmp.uuid) {
            jQuery(e).find('.jvc-cpuchart').data('cpuinfo', tmp);
          }
        })
      }

      if (jQuery('#jv-vmlist-host').children().length) {
        window.cuptimer = setTimeout(function() {
          vm_domain_stat(doms);
          clearTimeout(window.cuptimer);
        }, 3000);
      }

    },
    complete: function(XMLHttpRequest, textStatus) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });

}


// cpu
function cpuinit(t, v, init = false) {
  var chartCpuUsage = echarts.init(t);
  var color = '#1CDF7E';

  if (v > 50 && v <= 90) {
    color = '#FFC231';
  } else if (v > 90) {
    color = '#FF6854';
  } else {
    color = '#1CDF7E';
  }

  var optionCpuUsage = {
    series: [{
      data: [v],
      type: 'gauge',
      radius: 18,
      center: ['40%', '100%'],
      startAngle: 180,
      endAngle: 0,
      color: color,
      axisLine: {
        show: true,
        roundCap: true,
        lineStyle: {
          width: 6,
          color: [
            [1, '#F6F6F6']
          ]
        }
      },
      progress: {
        show: true,
        overlap: false,
        roundCap: true
      },
      pointer: {
        show: true,
        // length: '7%',
        width: 2,
        // offsetCenter: [0, '0%'],
        // icon: window.location.protocol + '//' + window.location.host + '/apps/vmdashboard/images/pointer.png',
      },
      anchor: {
        show: false
      },
      splitLine: {
        show: false
      },
      axisTick: {
        show: false
      },
      detail: {
        show: false
      },
      axisLabel: {
        show: false
      },
      title: {
        show: false
      }
    }]
  };
  chartCpuUsage.setOption(optionCpuUsage, true);
}

function cancelVmdSelected() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = jQuery(event.target);
  jQuery('#jv-vmlist-host input[name="vmcheckbox"]').prop("checked", false);
  jQuery('#jv-selectdhead').hide();
}

function selectAllVM() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = jQuery(event.target);
  var type = target.attr('type');
  if (type == 'selectall') {
    target.attr('type', 'deselectall');
    target.text(UNAS._('Deselect All'));
    jQuery('#jv-vmlist-host input[name="vmcheckbox"]').prop("checked", true);
  } else {
    target.attr('type', 'selectall');
    jQuery('#jv-vmlist-host input[name="vmcheckbox"]').prop("checked", false);
    target.text(UNAS._('Select All'));
    jQuery('#jv-selectdhead').hide();
  }


  var checked_len = jQuery('#jv-vmlist-host input[name="vmcheckbox"]:checked').length;
  var s = '';
  if (UNAS.CurrentLanguage == '简体中文') {
    s = UNAS._('Selected') + checked_len + '个' + UNAS._('##$@vmdashboard@$##Virtual Machines##$@vmdashboard@$##');
  } else {
    s = checked_len + UNAS._('##$@vmdashboard@$##Virtual Machines##$@vmdashboard@$##');
  }
  jQuery('#jv-vmdSelected').text(s);
}

function selectVm() {
  var checkbox_len = jQuery('#jv-vmlist-host input[name="vmcheckbox"]').length;
  var checked_len = jQuery('#jv-vmlist-host input[name="vmcheckbox"]:checked').length;
  var s = ""
  if (UNAS.CurrentLanguage == '简体中文') {
    s = UNAS._('Selected') + checked_len + '个' + UNAS._('##$@vmdashboard@$##Virtual Machines##$@vmdashboard@$##');
  } else {
    s = checked_len + UNAS._('##$@vmdashboard@$##Virtual Machines##$@vmdashboard@$##');
  }
  jQuery('#jv-vmdSelected').text(s);
  if (checked_len) {
    jQuery('#jv-selectdhead').show();
    if (checkbox_len == checked_len) {
      jQuery('#jv-vmdAllSelected').attr('type', 'deselectall');
      jQuery('#jv-vmdAllSelected').text(UNAS._('Deselect All'));
    } else {
      jQuery('#jv-vmdAllSelected').attr('type', 'selectall');
      jQuery('#jv-vmdAllSelected').text(UNAS._('Select All'));
    }
  } else {
    jQuery('#jv-selectdhead').hide();
  }

}

(function() {

  vm_domain_list().then(function() {
    vm_bg_tasks();
  });

})()
