function vm_domain_edit() {
  var domain = jQuery('#jv-vmname-edit').val();
  var description = jQuery('#jv-vmdescription').val();
  var domain_type = jQuery('input[name="unit"]:checked').val();
  var uefi = jQuery('#jv-uefi').prop('checked');
  var tpm = jQuery('#jv-tpm-edit').prop('checked');
  var cpu_mode = jQuery('#jv-cpumode').val();
  var topology_sockets = +jQuery('#jv-sockets').val() || 1;
  var topology_cores = +jQuery('#jv-cores').val() || 1;
  var topology_threads = +jQuery('#jv-threads').val() || 1;
  var memory = +jQuery('#jv-memory').val() || 1;
  var memory_unit = jQuery('input[name="memory_unit"]:checked').val();
  var vnc_autoport = JSON.parse(jQuery('#jv-vncautoport').val());
  var vnc_port = +jQuery('#jv-vncport-edit').val() || 5900;
  var remote_vnc_connect = JSON.parse(jQuery('#jv-vncconnect').val());
  var vnc_password = jQuery('#jv-vnc-password').val();
  var auto_start = false;
  var auto_start_delay = +jQuery('#jv-autostartdelay').val() || 0;
  if (jQuery('#jv-autostart').hasClass('open')) {
    auto_start = true
  }
  if (domain) {
    jQuery('#jv-vmname-edit').attr('class', 'unas_input');
  } else {
    jQuery('#jv-vmname-edit').attr('class', 'unas_input_error');
    return;
  }
  var params = {
    uuid: vmdetailinfo.uuid,
    domain: domain,
    description: description,
    domain_type: domain_type,
    uefi: uefi,
    tpm: tpm,
    cpu_mode: cpu_mode,
    topology_sockets: topology_sockets,
    topology_cores: topology_cores,
    topology_threads: topology_threads,
    memory: memory,
    memory_unit: memory_unit,
    vnc_autoport: vnc_autoport,
    remote_vnc_connect: remote_vnc_connect,
    vnc_port: vnc_port,
    vnc_password: vnc_password,
    auto_start: auto_start,
    auto_start_delay: auto_start_delay,
    start: false
  }

  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_domain_edit',
      token: UToken,
      params: params
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      // console.log(res);
      if (res.err == 0) {
        getvmdetail();
        MUI.closeWindow($('jv-editVMWindow'));
      } else {
        vm_errorWindowFn({
          tips: UNAS._('Operation failed, please check the log')
        })
      }
    },
    complete: function(XMLHttpRequest, textStatus) {
      vm_log();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

function autoStartControl(t, callback) {
  jQuery(t).toggleClass("open").children(".switch-btn").toggleClass("right");

  var clickType = jQuery(t).hasClass('open') ? true : false;

  if (typeof callback === 'function') {
    callback(clickType);
  }
  if (clickType) {
    jQuery('#jv-autostartdelay').attr('disabled', false);
  } else {
    jQuery('#jv-autostartdelay').attr('disabled', true);
  }
}

function vmdinfobasic() {
  jQuery('#jv-vmname-edit').val(vmdetailinfo.name);
  jQuery('#jv-vmdescription').val(vmdetailinfo.xml.description);
  jQuery('#jv-autostartdelay').val(vmdetailinfo.auto_start_delay || 0);
  var vmtype = vmdetailinfo.xml.attributes.type;
  vmtype = vmtype ? vmtype : 'kvm';
  jQuery('input[value="' + vmtype + '"]').prop('checked', true);
  if (vmdetailinfo.bios == "UEFI") {
    jQuery('#jv-uefi').prop('checked', true);
    jQuery('#jv-legacy').prop('checked', false);
  } else {
    jQuery('#jv-uefi').prop('checked', false);
    jQuery('#jv-legacy').prop('checked', true);
  }

  if (vmdetailinfo.tpm) {
    jQuery('#jv-tpm-edit').prop('checked', true);
  } else {
    jQuery('#jv-tpm-edit').prop('checked', false);
  }
  jQuery('#jv-cpumode').val(vmdetailinfo.xml.cpu.attributes.mode);
  jQuery('#jv-sockets').val(vmdetailinfo.xml.cpu.topology.attributes.sockets);
  jQuery('#jv-cores').val(vmdetailinfo.xml.cpu.topology.attributes.cores);
  jQuery('#jv-threads').val(vmdetailinfo.xml.cpu.topology.attributes.threads);
  var memory = +vmdetailinfo.xml.memory ? +vmdetailinfo.xml.memory : 0.1;
  memory = memory / 1024 / 1024;
  jQuery('#jv-memory').val(memory);
  var autoport = vmdetailinfo.xml.devices.graphics.attributes.autoport;
  if (autoport == 'yes') {
    jQuery('#jv-vncautoport').val('true');
    jQuery('#jv-vncport-edit').attr('disabled', true);
  } else {
    jQuery('#jv-vncautoport').val('false');
    jQuery('#jv-vncport-edit').attr('disabled', false);
  }
  var address = vmdetailinfo.xml.devices.graphics.listen.attributes.address;

  if (address == '0.0.0.0' || address == '::') {
    jQuery('#jv-vncconnect').val('true');
    jQuery('#jv-vnc-password').attr('disabled', false);
  } else {
    jQuery('#jv-vncconnect').val('false');
    jQuery('#jv-vnc-password').attr('disabled', true);
  }

  if (vmdetailinfo.auto_start) {
    jQuery('#jv-autostart').addClass("open").children(".switch-btn").addClass("right");
    jQuery('#jv-autostartdelay').attr('disabled', false);
  } else {
    jQuery('#jv-autostart').removeClass("open").children(".switch-btn").removeClass("right");
    jQuery('#jv-autostartdelay').attr('disabled', true);
  }

}

function vncautoportControl(t) {
  if (jQuery(t).val() == 'true') {
    jQuery('#jv-vncport-edit').attr('disabled', true);
  } else {
    jQuery('#jv-vncport-edit').attr('disabled', false);
  }
}

function vncconnectControl(t) {
  if (jQuery(t).val() == 'true') {
    jQuery('#jv-vnc-password').attr('disabled', false);
  } else {
    jQuery('#jv-vnc-password').attr('disabled', true);
  }
}

(function() {


  vmdinfobasic();
})()
