function diskClassify(arr) {
  var mergedArr = arr.reduce((result, current) => {
    var lastItem = result[result.length - 1];
    if (lastItem && lastItem[0].name[0] === current.name[0]) {
      lastItem.push(current);
    } else {
      result.push([current]);
    }
    return result;
  }, []);

  return mergedArr;
}

function getdisks() {
  var disks = diskClassify(vmdetailinfo.block) || [];
  jQuery('#jv-diskhost').empty();
  for (var i = 0; i < disks.length; i++) {
    var disk_tep = disks[i];
    var nodedom = vmdTemplateAppend('#jv-diskhost', 'jvt-vm-tbody', 'jvt-vm-tbody-' + i);
    for (var j = 0; j < disk_tep.length; j++) {
      var disk_data = disk_tep[j];
      var diskdom = vmdTemplateAppend(nodedom, 'jvt-disk-tr', 'jvt-disk-tr' + i + j);
      diskdom.attr('style', 'none');
      diskdom.find('.new-disk').text(disk_data.name);
      diskdom.find('.old-disk').text(disk_data.name);
      diskdom.find('.disk-path').text(disk_data.path).attr('title', disk_data.path);
      diskdom.find('.disk-type').text(disk_data.type);
      diskdom.find('.disk-driver').text(disk_data.xml.driver.attributes.type);
      var capacity = disk_data.capacity ? UNAS.getReadableSizeString(disk_data.capacity) : '--';
      diskdom.find('.disk-capacity').text(capacity);
      if (disk_tep.length > 1 && j == 0) {
        diskdom.find('.move-disk-up').addClass('up-icon-disable').removeClass('up-icon');
        diskdom.find('.move-disk-down').addClass('down-icon').removeClass('down-icon-disable');
      } else if (disk_tep.length > 1 && (disk_tep.length - 1) == j) {
        diskdom.find('.move-disk-up').addClass('up-icon').removeClass('up-icon-disable');
        diskdom.find('.move-disk-down').addClass('down-icon-disable').removeClass('down-icon');
      } else {
        if (disk_tep.length > 1) {
          diskdom.find('.move-disk-up').addClass('up-icon').removeClass('up-icon-disable');
          diskdom.find('.move-disk-down').addClass('down-icon').removeClass('down-icon-disable');
        } else {
          diskdom.find('.move-disk-up').addClass('up-icon-disable').removeClass('up-icon');
          diskdom.find('.move-disk-down').addClass('down-icon-disable').removeClass('down-icon');
        }
      }

      diskdom.find('.up-icon').on('click', function() {
        movedisk(this, 'prev');
      })

      diskdom.find('.down-icon').on('click', function() {
        movedisk(this, 'next');
      })

    }
  }
  vmdTranslator('jv-diskhost');

}
//

function movedisk(t, type) {
  var prev = {};
  if (type == 'prev') {
    prev = jQuery(t).parents('.vm-tr').prev();
  } else {
    prev = jQuery(t).parents('.vm-tr').next();
  }

  var prevmove = prev.find('div[type="move"]');

  var that = jQuery(t).parents('.vm-tr');
  var thatmove = that.find('div[type="move"]');

  for (var i = 0; i < prevmove.length; i++) {
    var p_v = jQuery(prevmove[i]).text();
    var t_v = jQuery(thatmove[i]).text();
    jQuery(prevmove[i]).text(t_v);
    jQuery(thatmove[i]).text(p_v);
  }

  jQuery(t).parents('.vm-tbody').children().each(function(i, e) {
    var new_disk = jQuery(e).find('.new-disk').text();
    var old_disk = jQuery(e).find('.old-disk').text();

    if (new_disk == old_disk) {
      jQuery(e).find('.new-disk').css('color', '#333');
    } else {
      jQuery(e).find('.new-disk').css('color', 'red');
    }
  })
}

function vm_domain_disk_resort(){
  var disk = {};
  jQuery('#jv-diskhost ul').each(function(i, e){
    var new_disk = jQuery(e).find('.new-disk').text();
    var old_disk = jQuery(e).find('.old-disk').text();
    disk[old_disk] = new_disk;
  })

  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_domain_disk_resort',
      token: UToken,
      params: {
        domain : vmdetailinfo.uuid,
        disk: disk
      }
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      if (res.err == 0) {
        MUI.closeWindow($('jv-resortDisksWindow'));
        getvmdetail();
      }else {
        vm_errorWindowFn({
          tips : UNAS._('Operation failed, please check the log')
        })
      }
    },
    complete: function(XMLHttpRequest, textStatus) {
      vm_log();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

(function() {
  // jQuery("#jv-resortdisks-main").mCustomScrollbar({
  //   autoHideScrollbar: true,
  //   theme: "minimal-dark"
  // });
  getdisks();

})()
