function vm_import_prepare() {
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_import_prepare',
      token: UToken,
      params: {
        source: jQuery('#jv-importfile').val()
      }
    }),
    success: function(res) {
      var info = res.results || [];
      if (info.length) {
        jQuery('#jv-importfileinfohost').empty().show();
        for (var i = 0; i < info.length; i++) {
          var dom = vmdTemplateAppend('#jv-importfileinfohost', 'jvt-fileinfoitem', 'jvt-fileinfoitem-' + i);
          dom.attr('style', '');
          dom.find('.name').html(info[i].name);
          dom.find('.stat').html(UNAS.getReadableSizeString(info[i].size));
        }
      }

    },
    complete: function(XMLHttpRequest, textStatus) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });

}


function submimportfileinfo() {
  var name = jQuery('#jv-vmname').val();
  var target_dir = jQuery('#jv-storagepath').val();
  var source = jQuery('#jv-importfile').val();
  var start = jQuery('#jv-autostart').prop('checked');
  if (!name) {
    jQuery('#jv-vmname').attr('class', 'unas_input_error');
    return;
  } else {
    jQuery('#jv-vmname').attr('class', 'unas_input');
  }
  if (!target_dir) {
    jQuery('#jv-storagepath').attr('class', 'unas_input_error');
    return;
  } else {
    jQuery('#jv-storagepath').attr('class', 'unas_input');
  }
  if (!source) {
    jQuery('#jv-importfile').attr('class', 'unas_input_error');
    return;
  } else {
    jQuery('#jv-importfile').attr('class', 'unas_input');
  }

  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_import',
      token: UToken,
      params: {
        domain: name,
        target_dir: target_dir,
        source: source,
        start: start
      }
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      if (res.err == 0) {
        MUI.closeWindow($('jv-importVMWindow'));
        vm_bg_tasks();
      } else {
        vm_errorWindowFn({
          tips: UNAS._(res.errmsg)
        })
      }
    },
    complete: function(XMLHttpRequest, textStatus) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });

}

function autoStartControl(t, callback) {
  jQuery(t).toggleClass("open").children(".switch-btn").toggleClass("right");

  var clickType = jQuery(t).hasClass('open') ? true : false;

  if (typeof callback === 'function') {
    callback(clickType);
  }

}

function uploadFile(file, dir, targetinput) {
  var chunkSize = 1024 * 1024; // 每片文件大小（1MB）
  var fileSize = file.size;
  var offset = 0;
  var progress = 0;
  var filename_encoded = encodeURIComponent(file.name);

  // 切片并上传
  function readAndUpload() {
    var reader = new FileReader();
    var blob = file.slice(offset, offset + chunkSize);
    jQuery('#jv-uploadloading').show();
    reader.onload = function(event) {
      var xhr = new XMLHttpRequest();
      xhr.open('POST', '/apps/vmdashboard/includes/upload.php', true);
      xhr.setRequestHeader('X-Target-Dir', dir);
      xhr.setRequestHeader('X-File', filename_encoded);
      xhr.setRequestHeader('X-Offset', offset);
      xhr.setRequestHeader('X-Size', fileSize);
      xhr.setRequestHeader('X-Chunk-Size', chunkSize);

      xhr.onload = function(data) {
        var res = JSON.parse(xhr.responseText);
        if (xhr.status === 200) {
          // 继续上传下一片
          if (res.err == 0) {
            offset += chunkSize;
            if (offset < fileSize) {
              readAndUpload();
              progress = ((offset / fileSize) * 100).toFixed(2);
              jQuery(targetinput).css('pointer-events', 'none');
              jQuery(targetinput).attr('placeholder', 'Uploading[' + progress + '%]: ' + file.name);
              jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn-disabled');
              jQuery('input[name="fileInput"]').attr('class', 'filest-disabled');

            } else {
              progress = 100;
              jQuery(targetinput).attr('placeholder', 'Uploading[' + progress + '%]: ' + file.name);
              jQuery(targetinput).css('pointer-events', 'auto');

              if (jQuery('input[name="storagepath"]').val()) {
                jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn');
                jQuery('input[name="fileInput"]').attr('class', 'filest');
              }else {
                jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn-disabled');
                jQuery('input[name="fileInput"]').attr('class', 'filest-disabled');
              }

              jQuery(targetinput).val(dir + '/' + file.name);
              vm_import_prepare();
              jQuery('#jv-uploadloading').hide();
            }
          }else {
            // console.error('文件上传失败.');
            vm_errorWindowFn({
              tips : UNAS._(uploadFilerrcode[res.err])
            })
            jQuery('#jv-uploadloading').hide();
          }

        } else {
          // console.error('文件上传失败.');

          jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn');
          jQuery('input[name="fileInput"]').attr('class', 'filest');
          vm_errorWindowFn({
            tips : UNAS._(uploadFilerrcode[res.err])
          })
          jQuery('#jv-uploadloading').hide();
        }
      };

      xhr.onerror = function() {
        jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn');
        jQuery('input[name="fileInput"]').attr('class', 'filest');
        jQuery('#jv-uploadloading').hide();
        vm_errorWindowFn({
          tips : UNAS._('Network error, file upload failed')
        })

      };

      xhr.send(event.target.result);
    };

    reader.readAsArrayBuffer(blob);
  }

  // 开始切片上传
  readAndUpload();
}


(function() {

  showpage('#jv-importvm-page');

  UNAS.Event.addEvent('sourceChange', function() {
    vm_import_prepare();
  });

  UNAS.Event.addEvent('dirChange', function() {
    if (jQuery('#jv-storagepath').val()) {
      jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn');
      jQuery('input[name="fileInput"]').attr('class', 'filest');
    } else {
      jQuery('div[name="selectfilebtn"]').attr('class', 'selectfilebtn-disabled');
      jQuery('input[name="fileInput"]').attr('class', 'filest-disabled');
    }
  });

  jQuery('#jv-fileInput').change(function(e) {
    var file = e.target.files[0];
    var dir = jQuery('#jv-storagepath').val();
    if (file) {
      uploadFile(file, dir, '#jv-importfile');
    }
  });

})();
