// power
function vm_power_control(cmd, domains, type) {
  jQuery('#jv-virtualmachines-loading').show();
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: cmd,
      token: UToken,
      params: {
        domains: domains
      }
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {

      if (res.err == 0) {
        vm_domain_list().then(function() {
          vm_bg_tasks();
        })
        if (type == 'pause') {
          UNAS.Event.addEvent('pause', function() {
            vm_domain_list();
          });
        }

      }else {
        vm_errorWindowFn({
          tips: UNAS._(res.errmsg)
        })
      }
    },
    complete: function(XMLHttpRequest, textStatus) {
      jQuery('#jv-virtualmachines-loading').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

// 后台任务检查
function vm_bg_tasks() {
  clearTimeout(window.taskstimer);
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "vm_bg_tasks",
      token: UToken
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      // console.log(res);
      if (res.err == 0) {
        var info = res.results || {};

        var is_task = 0;
        for (var v in info) {
          if (info.hasOwnProperty(v)) {
            if (info[v].length) {
              is_task = 1;
            }
          }
        }
        jQuery('#jv-vmlist-host').children().each(function(i, e) {
          var nodeinfo = jQuery(e).data('vmdinfo') || {};
          jQuery(e).find('.jvc-vmdloading').hide();
          jQuery(e).find('.jvc-state-task').hide();
          nodeinfo.state.state && jQuery(e).find('.jvc-vmdop').show();
          jQuery(e).find('.jvc-vmdstate').show();
        })

        info.clone.length && updateclonestate(info.clone, 'clone');
        info.export.length && updateclonestate(info.export, 'export');
        info.snapshot.length && updateclonestate(info.snapshot, 'snapshot');
        info.managedsave.length && updateclonestate(info.managedsave, 'managedsave');

        for (var i = 0; i < info.import.length; i++) {
          import_vms.push(info.import[i].DOMAIN);
        }

        import_vms = Array.from(new Set(import_vms));

        updateimportstate(info.import, 'import');
        if (info.import.length) {
          jQuery('#jv-importvmbtn').attr('disabled', true);
        }else {
          jQuery('#jv-importvmbtn').attr('disabled', false);
        }

        if (!info.managedsave.length) {
          UNAS.Event.fireEvent('pause');
        }

        if (!info.clone.length) {
          UNAS.Event.fireEvent('clonevm');
        }

        window.addEventListener("unload", function(e) {
          UNAS.Event.removeEvent('pause');
          UNAS.Event.removeEvent('clonevm');
        }, false);

        if (is_task) {

          if (jQuery('#jv-virtualmachines-page').length ) {
            window.taskstimer = setTimeout(function() {
              vm_bg_tasks();
              clearTimeout(window.taskstimer);
            }, 3000);
          }else {
            clearTimeout(window.taskstimer);
          }


        }

      }
    },
    complete: function(XMLHttpRequest, textStatus) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

function updateclonestate(data, type) {
  var tasksstate = {
    clone: '##$@vmdashboard@$##Cloning...##$@vmdashboard@$##',
    export: '##$@vmdashboard@$##Exporting...##$@vmdashboard@$##',
    snapshot: '##$@vmdashboard@$##Creating snapshot...##$@vmdashboard@$##',
    managedsave: '##$@vmdashboard@$##Pausing##$@vmdashboard@$##'
  }
  if (data.length) {
    var vmlist = jQuery('#jv-vmlist-host').children();
    for (var j = 0; j < vmlist.length; j++) {
      var e = vmlist[j];
      var nodeinfo = jQuery(e).data('vmdinfo') || {};
      for (var i = 0; i < data.length; i++) {
        var tmp = data[i];
        if (nodeinfo.uuid == tmp.UUID) {
          jQuery(e).find('.jvc-vmdloading').show();
          jQuery(e).find('.jvc-state-' + type).show().html(UNAS._(tasksstate[type]));
          jQuery(e).find('.jvc-vmdop').hide();
          jQuery(e).find('.jvc-vmdstate').hide();
          break;
        } else {
          jQuery(e).find('.jvc-vmdloading').hide();
          jQuery(e).find('.jvc-state-' + type).hide();
          jQuery(e).find('.jvc-vmdop').show();
          jQuery(e).find('.jvc-vmdstate').show();
        }
      }
    }
  } else {

  }

}

//
function updateimportstate(data, type) {
  var tasksstate = {
    import: '##$@vmdashboard@$##Importing...##$@vmdashboard@$##'
  }
  jQuery('#jv-vmlistimport-host').empty();
  var k = 0;
  for (var i = 0; i < data.length; i++) {
    var vmdom = vmdTemplateAppend('#jv-vmlistimport-host', 'jvt-vmditem-importing', 'jvt-vmditem-importing-' + i);
    vmdom.attr('style', 'none');
    vmdom.find('.jvc-state-import').html(UNAS._(tasksstate[type]));
    vmdom.find('.jvc-vmname').html(data[i].DOMAIN);
    vmdom.data('vmdinfo', data[i]);
  }

  var vmlist = jQuery('#jv-vmlistimport-host').children();
  if (vmlist.length) {
    for (var j = 0; j < vmlist.length; j++) {
      var e = vmlist[j];
      var nodeinfo = jQuery(e).data('vmdinfo') || {};
      if (import_vms.indexOf(nodeinfo.DOMAIN) > -1) {
        break;
      } else {
        vm_domain_list();
      }
    }
  } else {

    if (import_vms.length) {
      vm_domain_list();
      import_vms = [];
    }

  }

}

function searchvm(e){
  var event = window.event || arguments.callee.caller.arguments[0];
  var t = event.target;
  if (e) {
    t = e;
  }
  var v = jQuery(t).val().trim();
  jQuery("#jv-vmlist-host>ul:contains(" + v + ")").css('display', 'flex');
  jQuery("#jv-vmlist-host>ul:not(:contains(" + v + "))").hide();
}
