function setvmlist(arr) {
  jQuery('#jv-vmlisthost').empty();
  for (var i = 0; i < arr.length; i++) {
    var vp = arr[i];
    var pooldom = vmdTemplateAppend('#jv-vmlisthost', 'jvt-stpoolitem', 'jvt-stpoolitem-' + i);
    pooldom.find('.poolname-vm').text(vp.name || '--');
    pooldom.find('input[type=checkbox]').data('poolinfo', vp);
    pooldom.find('input[type=checkbox]').on('click', function() {
      var ck_len = jQuery('#jv-vmlisthost input[type=checkbox]:checked').length;
      if (ck_len) {
        jQuery('#jv-vmsnpset-nextbtn1').attr('class', 'unas_button_sub');
      } else {
        jQuery('#jv-vmsnpset-nextbtn1').attr('class', 'unas_button_sub_disabled');
      }
    })
  }
}

function addvmsnpTime() {

  var i = new Date().getTime();
  var h = jQuery('#vmsnp_hours').val();
  var m = jQuery('#vmsnp_minutes').val();
  var w_i = jQuery('#vmsnp_weeks').val();
  var days = jQuery('#vmsnp_days').val();
  var timetype = jQuery('input[name=schedule_type]:checked').val();

  var weekArray = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
  var week = weekArray[w_i];

  var timetext = '';
  switch (timetype) {
    case 'Daily':
      timetext = UNAS._('Daily') + ' ' + addTimeZero_vm(h) + ':' + addTimeZero_vm(m);
      break;
    case 'Weekly':
      timetext = UNAS._(week) + ' ' + addTimeZero_vm(h) + ':' + addTimeZero_vm(m);
      break;
    case 'Monthly':
      timetext = UNAS._('Monthly') + ' ' + days + UNAS._('st') + ' ' + addTimeZero_vm(h) + ':' + addTimeZero_vm(m);
      break;
    default:
  }

  var f = 0;
  jQuery('#jv-vmsnptimehost tr').each(function(i, e) {
    var content = jQuery(e).find('.timetx').attr('time');
    if (content == timetext) {
      f = 1;
      return;
    }
  })
  if (f) {
    return;
  }

  var tiemdom = vmdTemplateAppend('#jv-vmsnptimehost', 'jvt-vmsnptimeitem', 'jvt-vmsnptimeitem-' + i);

  tiemdom.find('.timetx').text(timetext).attr('time', timetext);
  tiemdom.find('.timetx').text(timetext).attr('val', timeToTimestamp_vm(h + ':' + m));

  switch (timetype) {
    case 'Daily':
      tiemdom.attr('h', h).attr('m', m).attr('week', '').attr('days', '');
      break;
    case 'Weekly':
      var w = (w_i == '0' ? 7 : w_i);
      tiemdom.attr('h', h).attr('m', m).attr('week', w).attr('days', '');
      break;
    case 'Monthly':
      tiemdom.attr('h', h).attr('m', m).attr('week', '').attr('days', days);
      break;
    default:
  }

  jQuery('#jv-vmsnptimehost tr').sort(function(a, b) {
    var contentA = jQuery(a).find('.timetx').attr('val');
    var contentB = jQuery(b).find('.timetx').attr('val');
    return (contentA < contentB) ? -1 : (contentA > contentB) ? 1 : 0;
  }).appendTo('#jv-vmsnptimehost');


  tiemdom.find('.delete-icon').on('click', function() {
    jQuery(this).parents('tr').remove();

    if (!jQuery('#jv-vmsnptimehost tr').children().length) {
      jQuery('#jv-vmsnp-nextbtn2-2').attr('class', 'unas_button_sub_disabled');
    }
  })

  if (jQuery('#jv-vmsnptimehost tr').children().length) {
    jQuery('#jv-vmsnp-nextbtn2-2').attr('class', 'unas_button_sub');
  }
}

function vm_snapshot_auto() {
  var domain = [],task = [];
  jQuery('#jv-vmlisthost input[type=checkbox]:checked').each(function(i, e) {
    var poolinfo = jQuery(e).data('poolinfo');
    domain.push(poolinfo.uuid);
  })
  jQuery('#jv-vmsnptimehost tr').each(function(i, e) {
    var h = jQuery(e).attr('h') || '*';
    var m = jQuery(e).attr('m') || '*';
    var w = jQuery(e).attr('week') || '*';
    var d = jQuery(e).attr('days') || '*';
    task.push({
      cron: [m, h, d, '*', w]
    })
  })
  var params = {
    domain: domain,
    autosnap: {
      task: task,
      archive: {
        on: jQuery('#jv-isenablearchive').prop('checked'),
        day: +jQuery('#jv-asd-day').val(),
        total: +jQuery('#jv-asd-total').val()
      }
    }
  };
  jQuery.ajax({
    url: vmUrl,
    data: JSON.encode({
      cmd: "vm_snapshot_auto",
      token: UToken,
      params: params
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {},
    complete: function(xml) {
      MUI.closeWindow($('jv-timedSnapshotWindow'));
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function setvmsnpstep(i) {
  jQuery('.jvc-set-step').hide();
  jQuery('#jv-set-step-' + i).fadeIn();
}

(function() {
  setvmlist(vmlist);
  jQuery('#vmsnp_daily').click(function() {
    jQuery('#vmsnp_weeks_cont').attr('style', "display:none");
    jQuery('#vmsnp_days_cont').attr('style', "display:none");
    jQuery('#vmsnp_days_cont').prop('disabled', false);
  })
  jQuery('#vmsnp_weekly').click(function() {
    jQuery('#vmsnp_weeks_cont').attr('style', "display:block;");
    jQuery('#vmsnp_days_cont').attr('style', "display:none");
    jQuery('#vmsnp_weeks').prop('disabled', false);
  })
  jQuery('#vmsnp_monthly').click(function() {
    jQuery('#vmsnp_weeks_cont').attr('style', "display:none");
    jQuery('#vmsnp_days_cont').attr('style', "display:block;");
    jQuery('#vmsnp_days').prop('disabled', false);
  })

  jQuery("#jv-vmlisthostcontent, #jv-vmtimehostcontent").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  var sel_hour = jQuery('#vmsnp_hours');
  var sel_minutes = jQuery('#vmsnp_minutes');
  var sel_weeks = jQuery('#vmsnp_weeks');
  var sel_days = jQuery('#vmsnp_days');
  var weekArray = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
  for (var i = 0; i < 24; i++) {
    sel_hour.append('<option value="' + i + '">' + i + '</option>');
  }
  for (var i = 0; i < 60; i++) {
    sel_minutes.append('<option value="' + i + '">' + i + '</option>');
  }
  for (var i = 1; i < 7; i++) {
    sel_weeks.append('<option value="' + i + '">' + UNAS._(weekArray[i]) + '</option>');
  }
  sel_weeks.append('<option value="0">' + UNAS._(weekArray[0]) + '</option>');
  for (var i = 1; i <= 31; i++) {
    sel_days.append('<option value="' + i + '">' + i + '</option>');
  }


  jQuery('#jv-asd-day, #jv-asd-total').bind('input propertychange', function(e) {
    var day = jQuery('#jv-asd-day').val();
    var total = jQuery('#jv-asd-total').val();
    if (day && total) {
      jQuery('#jv-vmsnp-nextbtn4').attr('class', 'unas_button_sub');
    } else {
      jQuery('#jv-vmsnp-nextbtn4').attr('class', 'unas_button_sub_disabled');
    }
  });

})()
