function vm_load_devices() {
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_load_devices',
      token: UToken
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      jQuery('#jv-passthroughdiskhost').empty();
      var info = res.results || {};
      if (res.err == 0) {
        var disk = info.disk || [];
        for (var i = 0; i < disk.length; i++) {
          var temp_disk = disk[i];
          var diskdom = vmdTemplateAppend('#jv-passthroughdiskhost', 'jvt-passthrough-disk-item', 'jvt-passthrough-disk-item-' + i);
          diskdom.attr('style', 'none')
          var name = '/dev/' + temp_disk.name;
          var model = name + " " + temp_disk.vendor + " " + temp_disk.model + " " + temp_disk.size

          diskdom.find('.jvc-diskname').html(model);
          diskdom.find('input[type="radio"]').val(name).on('click', function(){
            if (jQuery(this).prop('checked')) {
              jQuery('#jv-submit').attr('class', 'unas_button_sub');
            }
          })
        }
      }else {

      }

    },
    complete: function(XMLHttpRequest, textStatus) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

function addDiskPassthrough(){
  var disk = jQuery('#jv-passthroughdiskhost input[type="radio"]:checked').val();
  var params = {
    domain: vmdetailinfo.uuid,
    action : 'passthrough',
    disk: disk
  }

  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_domain_disk_attach',
      token: UToken,
      params: params
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      if (res.err == 0) {

        getvmdetail();
      }else if (res.err == 9958) {
        vm_succeedWindowFn({
          tips : UNAS._('Passthrough succeed. Please shutdown then poweron VM to use the passthrough disk')
        })
      } else {
        vm_errorWindowFn({
          tips : UNAS._('Operation failed, please check the log')
        })
      }
    },
    complete: function(XMLHttpRequest, textStatus) {
      MUI.closeWindow($('jv-addHostDeviceWindow'));
      vm_log();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

(function() {

  jQuery("#jv-devinfolist").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  vm_load_devices();
})()
