// edit vm
function editVMWindowFun() {
  var editVMWindow = new MUI.Modal({
    id: 'jv-editVMWindow',
    title: UNAS._("##$@vmdashboard@$##Edit Virtual Machine##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/edit_vm.html',
    modal: true,
    modalOverlayClose: false,
    width: 745,
    height: 540
  });
}

// 查看 xml
function viewVmConfigWindowFun(type, uuid, domain) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  var netinfo = {
    type: type,
    uuid: uuid,
    domain: domain
  };
  var viewHostConfigWindow = new MUI.Modal({
    id: 'jv-viewHostConfigWindow',
    title: UNAS._("##$@vmdashboard@$##XML Information##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/public/configinfo.html',
    modal: true,
    width: 760,
    height: 420,
    modalOverlayClose: false,
    data: netinfo
  });
}

// 调整磁盘顺序
function resortDisksWindowFun() {
  var resortDisksWindow = new MUI.Modal({
    id: 'jv-resortDisksWindow',
    title: UNAS._("##$@vmdashboard@$##Resort Disks##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/resortdisks.html',
    modal: true,
    modalOverlayClose: false,
    width: 1000,
    height: 460
  });
}
//添加存储卷
function addStorageVolumeWindowFun() {
  var addStorageVolumeWindow = new MUI.Modal({
    id: 'jv-addStorageVolumeWindow',
    title: UNAS._("##$@vmdashboard@$##Add Storage Volume##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/addstoragevolume.html',
    modal: true,
    modalOverlayClose: false,
    width: 650,
    height: 380
  });
}
//编辑存储卷
function editstoragevolumeWindowFun(t) {
  var diskinfo = jQuery(t).parents('ul[name=vmditem]').data('diskinfo');
  var data = {
    domain: vmdetailinfo.uuid,
    dev: diskinfo.name,
    disk: diskinfo.path,
    volume_bus: diskinfo.xml.target.attributes.bus
  }
  var editstoragevolumeWindow = new MUI.Modal({
    id: 'jv-editstoragevolumeWindow',
    title: UNAS._("##$@vmdashboard@$##Edit Storage Volume##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/editstoragevolume.html',
    modal: true,
    modalOverlayClose: false,
    data: data,
    width: 650,
    height: 210
  });

  editstoragevolumeWindow.callBack = function() {};
}

//删除disk
function deletestoragevolume(t) {
  var diskinfo = jQuery(t).parents('ul[name=vmditem]').data('diskinfo');
  var params = {
    domain: vmdetailinfo.uuid,
    dev: diskinfo.name
  }

  vm_alertWindowFn({
    tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##') + '?'
  }, function() {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.encode({
        cmd: 'vm_domain_disk_detach',
        token: UToken,
        params: params
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(res) {
        if (res.err == 0) {
          getvmdetail();
        } else {
          vm_errorWindowFn({
            tips: UNAS._('Operation failed, please check the log')
          })
        }
      },
      complete: function(XMLHttpRequest, textStatus) {
        vm_log();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
  });
}

//删除pci
function deletepci(t) {
  var diskinfo = jQuery(t).parents('ul[name=vmditem]').data('diskinfo');
  var params = {
    domain: vmdetailinfo.uuid
  }
  var cmd = '';
  if (diskinfo.iommu_group) {
    cmd = 'vm_passthrough_pci_del';
    params['iommu_group'] = diskinfo.iommu_group;
  } else {
    cmd = 'vm_passthrough_pci_del_raw';
    params['slot'] = diskinfo.slot;
  }

  vm_alertWindowFn({
    tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##') + '?'
  }, function() {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.encode({
        cmd: cmd,
        token: UToken,
        params: params
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(res) {
        if (res.err == 0) {
          getvmdetail();
        } else {
          vm_errorWindowFn({
            tips: UNAS._('Operation failed, please check the log')
          })
        }
      },
      complete: function(XMLHttpRequest, textStatus) {
        vm_log();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
  });
}

//删除usb
function deleteusb(t) {
  var diskinfo = jQuery(t).parents('ul[name=vmditem]').data('diskinfo');
  var params = {
    domain: vmdetailinfo.uuid,
    vendor_id: diskinfo.vendor_id,
    product_id: diskinfo.product_id
  }

  vm_alertWindowFn({
    tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##') + '?'
  }, function() {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.encode({
        cmd: 'vm_passthrough_usb_del',
        token: UToken,
        params: params
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(res) {
        if (res.err == 0) {
          getvmdetail();
        } else {
          vm_errorWindowFn({
            tips: UNAS._('Operation failed, please check the log')
          })
        }
      },
      complete: function(XMLHttpRequest, textStatus) {
        vm_log();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
  });
}

// 添加镜像
function addOpticalStorageWindowFun() {
  var addOpticalStorageWindow = new MUI.Modal({
    id: 'jv-addOpticalStorageWindow',
    title: UNAS._("##$@vmdashboard@$##Add Optical Storage##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/addopticalstorage.html',
    modal: true,
    modalOverlayClose: false,
    width: 650,
    height: 260
  });
}
//添加网卡Add Network Adapter
function addNetworkAdapterWindowFun(data) {
  var addNetworkAdapterWindow = new MUI.Modal({
    id: 'jv-addNetworkAdapterWindow',
    title: UNAS._("##$@vmdashboard@$##Add Network Adapter##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/addnetworkadapter.html',
    modal: true,
    modalOverlayClose: false,
    data: data,
    width: 650,
    height: 260
  });
}
//添加直通磁盘Add Host Device
function addHostDeviceWindowFun() {
  var addHostDeviceWindow = new MUI.Modal({
    id: 'jv-addHostDeviceWindow',
    title: UNAS._("##$@vmdashboard@$##Add Host Device##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/addhostdevice.html',
    modal: true,
    modalOverlayClose: false,
    width: 650,
    height: 500
  });
}
//添加PCI直通
function addPciWindowFun() {
  var addpciWindow = new MUI.Modal({
    id: 'jv-addpciWindow',
    title: UNAS._("##$@vmdashboard@$##Add PCI Node##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/addpci.html',
    modal: true,
    modalOverlayClose: false,
    width: 650,
    height: 500
  });
}
//添加USB直通
function addUsbWindowFun() {
  var addusbWindow = new MUI.Modal({
    id: 'jv-addusbWindow',
    title: UNAS._("##$@vmdashboard@$##Add USB Node##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/addusb.html',
    modal: true,
    modalOverlayClose: false,
    width: 650,
    height: 500
  });
}
//创建快照
function createSnapshotWindowFun(t) {

  var data = {
    uuid: vmdetailinfo.uuid,
    type: t
  }
  var createSnapshotWindow = new MUI.Modal({
    id: 'jv-createSnapshotWindow',
    title: UNAS._("##$@vmdashboard@$##Create Snapshot##$@vmdashboard@$##"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/createsnapshot.html',
    modal: true,
    modalOverlayClose: false,
    data: data,
    width: 650,
    height: 280
  });
}
// 图像
function set_cpu_memory(t, v) {
  var chartMemory = echarts.init(document.getElementById(t));
  var color = '#1CDF7E';

  if (v > 50 && v <= 90) {
    color = '#FFC231';
  } else if (v > 90) {
    color = '#FF6854';
  } else {
    color = '#1CDF7E';
  }

  var optionCpu = {
    series: [{
      data: [v],
      type: 'gauge',
      radius: '90%',
      center: ['50%', '50%'],
      startAngle: -270,
      endAngle: 90,
      clockwise: false,
      min: 0,
      max: 100,
      color: color,
      axisLine: {
        lineStyle: {
          width: 10,
          opacity: 1,
          color: [
            [1, '#F1F1F1']
          ]
        }
      },

      progress: {
        show: true,
        overlap: false,
        roundCap: true
      },

      detail: {
        offsetCenter: [10, '0%'],
        valueAnimation: true,
        formatter: function(value) {
          return '{value|' + Math.round(value) + '%}  ';
        },
        rich: {
          value: {
            textAlign: 'center',
            fontSize: 18,
            fontWeight: 500,
            color: '#555'
          }
        }
      },

      axisTick: {
        show: false
      },
      pointer: {
        show: false
      },
      splitLine: {
        show: false,
      },
      axisLabel: {
        show: false
      }
    }]
  };
  chartMemory.setOption(optionCpu, true);
}


//硬盘读写速度
function setchart(chart, data, ts) {
  chart.setOption({
    series: [{
      data: data
    }],
    xAxis: [{
      data: ts
    }],
    tooltip: {
      formatter: function(params) {}
    }
  });
}

function setOption_rw(name, bgcolor, data) {



  var option = {
    animation: false,
    xAxis: {
      show: false,
      type: 'category',
      boundaryGap: false,
      data: [0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, '60s'],
      axisLabel: {
        fontSize: 10,
        // interval: 10
      },
      inverse: true,
    },

    tooltip: {
      trigger: 'axis',
      formatter: function(params) {
        var result = '';
        for (var i = 0; i < params.length; i++) {
          result = result + params[i].marker + params[i].seriesName + ': ' +
            UNAS.getReadableSpeedString(params[i].value) + '</br>';
        }
        return result;
      },
      enterable: 'true',
    },
    yAxis: {
      type: 'value',
      show: false,
    },

    grid: {
      top: 0,
      left: 0,
      right: 0,
      height: '100%',
      width: '100%'
    },
    series: [{
      data: data,
      name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##'),
      type: 'line',
      smooth: true,
      color: bgcolor.color0,
      areaStyle: {
        color: {
          type: 'linear',
          x: 0,
          y: 0,
          x2: 0,
          y2: 1,
          colorStops: [{
            offset: 0,
            color: bgcolor.color0 // 0% 处的颜色
          }, {
            offset: 1,
            color: bgcolor.color1 // 100% 处的颜色
          }],
          global: false // 缺省为 false
        },
        shadowBlur: 0,
        // opacity: 0.2
      },
      // 设置小圆点消失
      // 注意：设置symbol: 'none'以后，拐点不存在了，设置拐点上显示数值无效
      symbol: 'none',
      // 设置折线弧度，取值：0-1之间
      smooth: true,
      lineStyle: {
        width: 2
      }
    }]

  };

  return option;
}


function setReceived_sent(name, color, data) {

  var option = {
    animation: false,
    xAxis: {
      show: false,
      type: 'category',
      boundaryGap: false,
      data: [0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, '60s'],
      axisLabel: {
        fontSize: 10,
        interval: 19
      },
      inverse: true
    },
    tooltip: {
      trigger: 'axis',
      formatter: function(params) {
        var result = '';
        for (var i = 0; i < params.length; i++) {
          result = result + params[i].marker + params[i].seriesName + ': ' +
            UNAS.getReadableSpeedString(params[i].value) + '</br>';
        }
        return result;
      }
    },
    yAxis: {
      show: false,
      type: 'value',
      name: 'K/s'
    },
    grid: {
      top: 20,
      left: 0,
      right: 20,
      height: '58%',
      width: '90%'
    },
    series: {
      name: UNAS._(name),
      type: 'line',
      symbolSize: 0,
      color: color,
      smooth: true,
      data: data
    }
  };
  return option;
}

function goback() {
  updatevmpage(backhtml);
}

var diskReadChart = null;
var diskReadData = [0];
var diskWriteChart = null;
var diskWriteData = [0];


//网络发送
var sentChart = null;
var network_sent = [0];
//网络接受
var receiveChart = null;
var network_io = [0];


(function() {

  // jQuery("#jv-vmdetail-page").mCustomScrollbar({
  //   autoHideScrollbar: true,
  //   theme: "minimal-dark"
  // });

  jQuery("#jv-vmdetail-main").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });



  jQuery("#jv-timeline").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  diskReadChart = echarts.init(document.getElementById('jv-disk-read'))
  setOption_rw('', diskReadData) && diskReadChart.setOption(setOption_rw('Read', {
    color0: '#A1EEC8',
    color1: '#ECFBF4'
  }, diskReadData));

  diskWriteChart = echarts.init(document.getElementById('jv-disk-write'))
  setOption_rw('', diskWriteData) && diskWriteChart.setOption(setOption_rw('Write', {
    color0: '#FEDEA0',
    color1: '#FFF8E7'
  }, diskWriteData));

  sentChart = echarts.init(document.getElementById("jv-sent"));
  setReceived_sent('', network_sent) && sentChart.setOption(
    setReceived_sent('Sent', '#35DFFF', network_sent))

  receiveChart = echarts.init(document.getElementById("jv-received"));
  setReceived_sent('', network_io) && receiveChart.setOption(
    setReceived_sent('Received', '#FF7D4F', network_io))

  getvmdetail().then(function(){
    vm_dettail_tasks();
  });
})()
